

theory example_3 imports Isac.Isac_Knowledge
begin

section\<open>Function Declaration\<close>
text\<open>Following code should only represent an example and was taken as a
      snipset from Rationals.thy located in 
      \texttt{/src/Tools/isac/Knowledge}\<close>

(*----START----Example Function Declaration from Rationals.thy----*)

text\<open>Define MethodC name and input, output types\<close>

consts
  get_denominator :: "real => real"

text\<open>Always add a comment with the method name and where it can be found.\<close>
  
ML \<open>
(*
 *("get_denominator",
 *  ("Rational.get_denominator", eval_get_denominator ""))
 *)
fun eval_get_denominator (thmid:string) _ 
		      (t as Const ("Rational.get_denominator", _) $
              (Const ("Rings.divide_class.divide", _) $num 
                $denom)) thy = 
        SOME (TermC.mk_thmid thmid (UnparseC.term_in_thy thy denom) "", 
	        HOLogic.Trueprop $ (TermC.mk_equality (t, denom)))
  | eval_get_denominator _ _ _ _ = NONE; 
\<close>
(*----END----Example Function Decleration from Rationals.thy----*)

text\<open>Apply the MethodC to an expression.\<close>

ML\<open>
  val input = Thm.term_of (the (TermC.parse thy "get_denominator ((a + b) / c)"));
  val SOME (_, output) = eval_get_denominator "" 0 input thy;
\<close>

ML\<open>
 UnparseC.term output;
\<close>

end
