(* Title: tests for libisabelle
          https://github.com/wneuper/libisabelle cloned from ...
          https://github.com/larsrh/libisabelle
   Author: Walther Neuper 2015
   Use is subject to license terms.
*)

"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------";
"-----------------------------------------------------------------------------";
"-------- mini-test ----------------------------------------------------------";
"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";


"-------- mini-test ----------------------------------------------------------";
"-------- mini-test ----------------------------------------------------------";
"-------- mini-test ----------------------------------------------------------";
(* see 
https://github.com/wneuper/libisabelle/blob/master/doc/test--isac-Java--isac-kernel.txt*)
reset_states ();  (*resets all state information in Kernel           *)

"----------- step 1: operation_setup calctree --------------------------------------------------";
val items = ["equality (x+1=(2::real))", "solveFor x", "solutions L"]
val spec = ("Test", ["sqroot-test", "univariate", "equation", "test"], ["Test", "squ-equ-test-subpbl1"])
val intree = xml_of_fmz [(items, spec)]
(* --- VARIANT was missing:
val intree = 
<FORMALIZATION>
  <VARIANT>
    <STRINGLIST>
      <STRING>equality (x+1=(2::real))</STRING>
      <STRING>solveFor x</STRING>
      <STRING>solutions L</STRING>
    </STRINGLIST>
  <SPECIFICATION>
    <THEORYID>Test</THEORYID>
    <PROBLEMID>
      <STRINGLIST>
        <STRING>sqroot-test</STRING>
        <STRING>univariate</STRING>
        <STRING>equation</STRING>
        <STRING>test</STRING>
      </STRINGLIST>
    </PROBLEMID>
    <METHODID>
      <STRINGLIST>
        <STRING>Test</STRING>
        <STRING>squ-equ-test-subpbl1</STRING>
        </STRINGLIST>
      </METHODID>
    </SPECIFICATION>
  </VARIANT>
</FORMALIZATION>:
*)
;
"~~~~~ operation_setup calctree, args:"; val intree = 
  (xml_of_fmz [(["equality (x+1=(2::real))", "solveFor x", "solutions L"],
    ("Test",["sqroot-test", "univariate", "equation", "test"],["Test", "squ-equ-test-subpbl1"]))])
	   val fmz = case intree of
	       tree as XML.Elem (("FORMALIZATION", []), _) => xml_to_fmz tree
       | tree => error ("calctree: intree =" ^ xmlstr 0 tree)

	   val result = CalcTree fmz (* <--------------------------------- *)
;
val calcid = case result of
  XML.Elem (("CALCTREE", []), [
    XML.Elem (("CALCID", []), [XML.Text calcid])]) => int_of_str calcid
| tree => error ("test--isac-java--isac-kernel step 1: operation_setup calctree changed, out = \n" ^
    xmlstr 0 tree);
result |> xmlstr 0 |> writeln (*
<CALCTREE>
. <CALCID>
. . 1
. </CALCID>
</CALCTREE>
*)
;
"----------- step 2: operation_setup iterator --------------------------------------------------";
"~~~~~ operation_setup iterator, args:"; val calcid = calcid
val out = Iterator calcid (* <--------------------------------- *)
val XML.Elem (("ADDUSER", []),
         [XML.Elem (("CALCID", []), [XML.Text calcid]),
         XML.Elem (("USERID", []), [XML.Text userid])]) = out;
"~~~~~ operation_setup iterator";
"calcid = "; calcid;
"userid = "; userid;
if calcid = "1" andalso userid = "1" then () 
else error "test--isac-java--isac-kernel step 2: operation_setup iterator changed"
out |> xmlstr 0 |> writeln (*
<ADDUSER>
. <CALCID>
. . 1
. </CALCID>
. <USERID>
. . 1
. </USERID>
</ADDUSER>
*)
;
"----------- step 3: operation_setup moveactiveroot --------------------------------------------";
"~~~~~ operation_setup moveactiveroot, args:"; val calcid = calcid
val out = moveActiveRoot (int_of_str calcid) (* <--------------------------------- *)
val XML.Elem (("CALCITERATOR", []), [
      XML.Elem (("CALCID", []), [XML.Text calcid]),
      XML.Elem (("POSITION", []), [
        XML.Elem (("INTLIST", []), is),
        XML.Elem (("POS", []), [XML.Text kind])])]) = out;
if calcid = "1" andalso is = [] andalso kind = "Pbl" then ()
else error "test--isac-java--isac-kernel step 3: operation_setup moveactiveroot changed";
out |> xmlstr 0 |> writeln (*
<CALCITERATOR>
. <CALCID>
. . 1
. </CALCID>
. <POSITION>
. . <INTLIST>
. . </INTLIST>
. . <POS>
. . . Pbl
. . </POS>
. </POSITION>
</CALCITERATOR>
*)
;
"----------- step 4: operation_setup getformulaefromto -----------------------------------------";
val pos as (is, kind) = ([], Pbl)
val calcformula as (pos, formula) = (pos, "solve (x + 1 = 2, x)")
val formheads = [calcformula (*, calchead .. see below*)]
val intree = (* CREATE THIS IN Mini_Test.java *)
  XML.Elem (("GETFORMULAEFROMTO", []), [
    XML.Elem (("CALCID", []), 
      [XML.Text  calcid]),
      xml_of_pos "POSITION" (is, kind),
      xml_of_pos "POSITION" (is, kind),
      xml_of_int 0,
      xml_of_bool false]);
"~~~~~ operation_setup getformulaefromto, args:"; val calcid = calcid
	   val (ci, from, to, level, rules) = case intree of
       XML.Elem (("GETFORMULAEFROMTO", []), [
         XML.Elem (("CALCID", []), [XML.Text calcid]),
         from as XML.Elem (("POSITION", []), [
           XML.Elem (("INTLIST", []), _),
           XML.Elem (("POS", []), [XML.Text _])]),
         to as XML.Elem (("POSITION", []), [
           XML.Elem (("INTLIST", []), _),
           XML.Elem (("POS", []), [XML.Text _])]),
         XML.Elem (("INT", []), [XML.Text level]),
         XML.Elem (("BOOL", []), [XML.Text rules])]) => (calcid, from, to, level, rules)
     | tree => error ("getformulaefromto: WRONG intree = " ^ xmlstr 0 tree)
     val SOME calcid = ThmC_Def.int_opt_of_string calcid
     val from = xml_to_pos from
     val to = xml_to_pos to
     val SOME level = (*xml_to_int*) ThmC_Def.int_opt_of_string level
     val rules = (*xml_to_bool*) string_to_bool rules
     val out = getFormulaeFromTo calcid from to level rules (* <-------------------- *)
;
(*//---------------------------------- rm libisabelle ---------------------------------------\\* )
if xmlstr 0 out = 
"(GETELEMENTSFROMTO)\n. (CALCID)\n. . 1\n. (/CALCID)\n. (FORMHEADS)\n. . (CALCFORMULA)\n. . . (POSITION)\n. . . . (INTLIST)\n. . . . (/INTLIST)\n. . . . (POS)\n. . . . . Pbl\n. . . . (/POS)\n. . . (/POSITION)\n. . . (FORMULA)\n. . . . (ISA)\n. . . . . solve (x + 1 = 2, x)\n. . . . (/ISA)\n. . . . (TERM)\n. . . . . solve (x + 1 = 2, x)\n. . . . (/TERM)\n. . . (/FORMULA)\n. . (/CALCFORMULA)\n. (/FORMHEADS)\n(/GETELEMENTSFROMTO)\n"
then () else error "test--isac-java--isac-kernel step 4: operation_setup getformulaefromto CHANGED";
out |> xmlstr 0 |> writeln (*
( *\\---------------------------------- rm libisabelle ---------------------------------------//*)
<GETELEMENTSFROMTO>
. <CALCID>
. . 1
. </CALCID>
. <FORMHEADS>
. . <CALCFORMULA>
. . . <POSITION>
. . . . <INTLIST>
. . . . </INTLIST>
. . . . <POS>
. . . . . Pbl
. . . . </POS>
. . . </POSITION>
. . . <FORMULA>
. . . . <MATHML>
. . . . . <ISA>
. . . . . . solve (x + 1 = 2, x)
. . . . . </ISA>
. . . . </MATHML>
. . . </FORMULA>
. . </CALCFORMULA>
. </FORMHEADS>
</GETELEMENTSFROMTO>
*)
;
(* TODO ...*)
"----------- step 5: operation_setup refformula ------------------------------------------------";
"~~~~~ operation_setup getformulaefromto, args:"; val () = ()
;
"----------- step 6: operation_setup refformula ------------------------------------------------";
(* intree von TestPIDE.java:
<REFFORMULA>
  <CALCID>1</CALCID>
  <POSITION>
    <INTLIST/>
    <POS>Pbl</POS>
  </POSITION>
</REFFORMULA>*)
if ci = "1" then () else error "--- step 6: ci <> 1";
val intree = 
  XML.Elem (("REFFORMULA", []), [
    XML.Elem (("CALCID", []), [XML.Text ci]), 
    XML.Elem (("POSITION", []), [
      XML.Elem (("INTLIST", []), []),
      XML.Elem (("POS", []), [XML.Text "Pbl"])])])
;
"~~~~~ operation_setup refformula, args:"; val intree = intree;
	   val (ci, p) = 
       case intree of
         XML.Elem (("REFFORMULA", []), [
             XML.Elem (("CALCID", []), [XML.Text ci]), 
             p]) => (ci, p)
      | _ => error "operation_setup refformula intree changed"
     val SOME calcid = ThmC_Def.int_opt_of_string ci
     val pos = xml_to_pos p
;
if calcid = 1 andalso pos = ([], Pbl) then () else error "--- step 6: intree changed";
     val result = refFormula calcid pos
;
(*this vanished by now..*)
xmlstr 0 result = "<REFFORMULA>\n. <CALCID>\n. . 1\n. </CALCID>\n. <ERROR>\n. .  pos does not exist \n. </ERROR>\n</REFFORMULA>\n"
;
"----------- step 7: operation_setup autocalculate ---------------------------------------------";
"~~~~~ operation_setup autocalculate, args:"; val () = ()
;
"----------- step 8: operation_setup getformulaefromto -----------------------------------------";
"~~~~~ operation_setup getformulaefromto, args:"; val () = ()
;
"----------- step 9: operation_setup getformulaefromto -----------------------------------------";
"~~~~~ operation_setup getformulaefromto, args:"; val () = ()
;
"----------- step 10: operation_setup refformula -----------------------------------------------";
"~~~~~ operation_setup refformula, args:"; val () = ()
;
"----------- step 11: operation_setup refformula -----------------------------------------------";
"~~~~~ operation_setup refformula, args:"; val () = ()
;
"----------- step 12: operation_setup refFormula -----------------------------------------------";
"~~~~~ operation_setup refformula, args:"; val () = ()
;
"----------- step 13: operation_setup deconstrcalctree -----------------------------------------";
"~~~~~ operation_setup deconstrcalctree, args:"; val () = ()

