(* minimal example on problem with open structure *)

signature PERVASIVE =
sig
  datatype foo = Foo of string
end
structure Pervasive : PERVASIVE = (* e.g. Ctree : CALC_TREE *)
struct
  datatype foo = Foo of string
end
(* this here is required in order to get "evaluated with def.2": open Pervasive *)
(* TODO un-comment ...                                           ^^^^^^^^^^^^^^ *)

signature OPENED =
sig
  val bar_opened : 'a list -> Pervasive.foo
end
structure Opened : OPENED = (* e.g. LI : LUCAS_INTERPRETER *)
struct
  open Pervasive
  fun bar_opened [] = Foo "evaluated with def.1"
    | bar_opened (_ :: _) = Foo "evaluated with def.2"
end

signature CLOSED =
sig
  val bar_closed : 'a list -> Pervasive.foo
end
structure Closed : CLOSED = (* e.g. Math_Engine : MATH_ENGINE *)
struct
  fun bar_closed [] = Pervasive.Foo "evaluated with def.1"
    | bar_closed (_ :: _) = Pervasive.Foo "evaluated with def.2"
end

(* test/Tools/isac/* ..*)
open Pervasive;
open Opened;
open Closed;
bar_closed [1] = Foo "evaluated with def.2"; (* .. one should be def.1 ..TODO *)
bar_opened [1] = Foo "evaluated with def.2"; (* .. one should be def.1 ..TODO *)
