(* title:  Knowledge/polyminus.sml
   author: Walther Neuper
   WN071207,
   (c) due to copyright terms
*)
"--------------------------------------------------------";
"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- fun eval_ist_monom -------------------------";
"----------- watch order_add_mult  ----------------------";
"----------- build predicate for +- ordering ------------";
"----------- build fasse_zusammen -----------------------";
"----------- build verschoenere -------------------------";
"----------- met simplification for_polynomials with_minu";
"----------- me simplification.for_polynomials.with_minus";
"----------- pbl polynom vereinfachen p.33 --------------";
"----------- met probe fuer_polynom ---------------------";
"----------- pbl polynom probe --------------------------";
"----------- pbl klammer polynom vereinfachen p.34 ------";
"----------- try fun applyTactics -----------------------";
"----------- pbl binom polynom vereinfachen p.39 --------";
"----------- pbl binom polynom vereinfachen: cube -------";
"----------- Refine.refine Vereinfache -------------------------";
"----------- *** Problem.prep_input: syntax error in '#Where' of [v";
"--------------------------------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";

val thy = @{theory "PolyMinus"};

"----------- fun eval_ist_monom ----------------------------------";
"----------- fun eval_ist_monom ----------------------------------";
"----------- fun eval_ist_monom ----------------------------------";
ist_monom (str2term "12");
case eval_ist_monom 0 0 (str2term "12 ist_monom") 0 of
    SOME ("12 ist_monom = True", _) => ()
  | _ => error "polyminus.sml: 12 ist_monom = True";

case eval_ist_monom 0 0 (str2term "a ist_monom") 0 of
    SOME ("a ist_monom = True", _) => ()
  | _ => error "polyminus.sml: a ist_monom = True";

case eval_ist_monom 0 0 (str2term "(3*a) ist_monom") 0 of
    SOME ("3 * a ist_monom = True", _) => ()
  | _ => error "polyminus.sml: 3 * a ist_monom = True";

case eval_ist_monom 0 0 (str2term "(a^^^2) ist_monom") 0 of 
   SOME ("a ^^^ 2 ist_monom = True", _) => ()
  | _ => error "polyminus.sml: a^^^2 ist_monom = True";

case eval_ist_monom 0 0 (str2term "(3*a^^^2) ist_monom") 0 of
    SOME ("3 * a ^^^ 2 ist_monom = True", _) => ()
  | _ => error "polyminus.sml: 3*a^^^2 ist_monom = True";

case eval_ist_monom 0 0 (str2term "(a*b) ist_monom") 0 of
    SOME ("a * b ist_monom = True", _) => ()
  | _ => error "polyminus.sml: a*b ist_monom = True";

case eval_ist_monom 0 0 (str2term "(3*a*b) ist_monom") 0 of
    SOME ("3 * a * b ist_monom = True", _) => ()
  | _ => error "polyminus.sml: 3*a*b ist_monom = True";


"----------- watch order_add_mult  -------------------------------";
"----------- watch order_add_mult  -------------------------------";
"----------- watch order_add_mult  -------------------------------";
"----- with these simple variables it works...";
(*Rewrite.trace_on := true; ..stopped Test_Isac.thy*)
Rewrite.trace_on:=false;
val t = str2term "((a + d) + c) + b";
val SOME (t,_) = rewrite_set_ thy false order_add_mult t; UnparseC.term t;
if UnparseC.term t = "a + (b + (c + d))" then ()
else error "polyminus.sml 1 watch order_add_mult";
Rewrite.trace_on:=false;

"----- the same stepwise...";
val od = ord_make_polynomial true (@{theory "Poly"});
val t = str2term "((a + d) + c) + b";
"((a + d) + c) + b"; 
val SOME (t,_) = rewrite_ thy od Rule_Set.empty true @{thm add.commute} t; UnparseC.term t;
"b + ((a + d) + c)";
val SOME (t,_) = rewrite_ thy od Rule_Set.empty true @{thm add.commute} t; UnparseC.term t;
"b + (c + (a + d))";
val SOME (t,_) = rewrite_ thy od Rule_Set.empty true @{thm add.left_commute} t;UnparseC.term t;
"b + (a + (c + d))";
val SOME (t,_) = rewrite_ thy od Rule_Set.empty true @{thm add.left_commute} t;UnparseC.term t;
"a + (b + (c + d))";
if UnparseC.term t = "a + (b + (c + d))" then ()
else error "polyminus.sml 2 watch order_add_mult";

"----- if parentheses are right, left_commute is (almost) sufficient...";
val t = str2term "a + (d + (c + b))";
"a + (d + (c + b))";
val SOME (t,_) = rewrite_ thy od Rule_Set.empty true @{thm add.left_commute} t;UnparseC.term t;
"a + (c + (d + b))";
val SOME (t,_) = rewrite_ thy od Rule_Set.empty true @{thm add.commute} t;UnparseC.term t;
"a + (c + (b + d))";
val SOME (t,_) = rewrite_ thy od Rule_Set.empty true @{thm add.left_commute} t;UnparseC.term t;
"a + (b + (c + d))";

"----- but we do not want the parentheses at right; thus: cond.rew.";
"WN0712707 complicated monomials do not yet work ...";
val t = str2term "((5*a + 4*d) + 3*c) + 2*b";
val SOME (t,_) = rewrite_set_ thy false order_add_mult t; UnparseC.term t;
if UnparseC.term t = "2 * b + (3 * c + (4 * d + 5 * a))" then ()
else error "polyminus.sml: order_add_mult changed";

"----- here we see rew_sub going into subterm with ord.rew....";
val od = ord_make_polynomial false (@{theory "Poly"});
val t = str2term "b + a + c + d";
val SOME (t,_) = rewrite_ thy od Rule_Set.empty false @{thm add.commute} t; UnparseC.term t;
val SOME (t,_) = rewrite_ thy od Rule_Set.empty false @{thm add.commute} t; UnparseC.term t;
(*@@@ rew_sub gosub: t = d + (b + a + c)
  @@@ rew_sub begin: t = b + a + c*)


"----------- build predicate for +- ordering ---------------------";
"----------- build predicate for +- ordering ---------------------";
"----------- build predicate for +- ordering ---------------------";
"a" < "b";
"ba" < "ab";
"123" < "a"; (*unused due to ---vvv*)
"12" < "3"; (*true !!!*)

" a kleiner b ==> (b + a) = (a + b)";
str2term "aaa";
str2term "222 * aaa";

case eval_kleiner 0 0 (str2term "123 kleiner 32") 0 of
    SOME ("123 kleiner 32 = False", _) => ()
  | _ => error "polyminus.sml: 12 kleiner 9 = False";

case eval_kleiner 0 0 (str2term "a kleiner b") 0 of
    SOME ("a kleiner b = True", _) => ()
  | _ => error "polyminus.sml: a kleiner b = True";

case eval_kleiner 0 0 (str2term "(10*g) kleiner f") 0 of
    SOME ("10 * g kleiner f = False", _) => ()
  | _ => error "polyminus.sml: 10 * g kleiner f = False";

case eval_kleiner 0 0 (str2term "(a^^^2) kleiner b") 0 of
    SOME ("a ^^^ 2 kleiner b = True", _) => ()
  | _ => error "polyminus.sml: a ^^^ 2 kleiner b = True";

case eval_kleiner 0 0 (str2term "(3*a^^^2) kleiner b") 0 of
    SOME ("3 * a ^^^ 2 kleiner b = True", _) => ()
  | _ => error "polyminus.sml: 3 * a ^^^ 2 kleiner b = True";

case eval_kleiner 0 0 (str2term "(a*b) kleiner c") 0 of
    SOME ("a * b kleiner c = True", _) => ()
  | _ => error "polyminus.sml: a * b kleiner b = True";

case eval_kleiner 0 0 (str2term "(3*a*b) kleiner c") 0 of
    SOME ("3 * a * b kleiner c = True", _) => ()
  | _ => error "polyminus.sml: 3 * a * b kleiner b = True";

"======= compare tausche_plus with real_num_collect";
val od = dummy_ord;

val erls = erls_ordne_alphabetisch;
val t = str2term "b + a";
val SOME (t,_) = rewrite_ thy od erls false @{thm tausche_plus} t; UnparseC.term t;
if UnparseC.term t = "a + b" then ()
else error "polyminus.sml: ordne_alphabetisch1 b + a";

val erls = Atools_erls;
val t = str2term "2*a + 3*a";
val SOME (t,_) = rewrite_ thy od erls false @{thm real_num_collect} t; UnparseC.term t;

"======= test rewrite_, rewrite_set_";
(*Rewrite.trace_on := true; ..stopped Test_Isac.thy*)
val erls = erls_ordne_alphabetisch;
val t = str2term "b + a";
val SOME (t,_) = rewrite_set_ thy false ordne_alphabetisch t; UnparseC.term t;
if UnparseC.term t = "a + b" then ()
else error "polyminus.sml: ordne_alphabetisch a + b";

val t = str2term "2*b + a";
val SOME (t,_) = rewrite_set_ thy false ordne_alphabetisch t; UnparseC.term t;
if UnparseC.term t = "a + 2 * b" then ()
else error "polyminus.sml: ordne_alphabetisch a + 2 * b";

val t = str2term "a + c + b";
val SOME (t,_) = rewrite_set_ thy false ordne_alphabetisch t; UnparseC.term t;
if UnparseC.term t = "a + b + c" then ()
else error "polyminus.sml: ordne_alphabetisch a + b + c";

"======= rewrite goes into subterms";
val t = str2term "a + c + b + d";
val SOME (t,_) = rewrite_ thy od erls false @{thm tausche_plus_plus} t; UnparseC.term t;
if UnparseC.term t = "a + b + c + d" then ()
else error "polyminus.sml: ordne_alphabetisch1 a + b + c + d";

val t = str2term "a + c + d + b";
val SOME (t,_) = rewrite_set_ thy false ordne_alphabetisch t; UnparseC.term t;
if UnparseC.term t = "a + b + c + d" then ()
else error "polyminus.sml: ordne_alphabetisch2 a + b + c + d";

"======= here we see rew_sub going into subterm with cond.rew....";
val t = str2term "b + a + c + d";
val SOME (t,_) = rewrite_ thy od erls false @{thm tausche_plus} t; UnparseC.term t;
if UnparseC.term t = "a + b + c + d" then ()
else error "polyminus.sml: ordne_alphabetisch3 a + b + c + d";

"======= compile rls for the most complicated terms";
val t = str2term "5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12";
"5 * e + 6 * f - 8 * g - 9 - 7 * e - 4 * f + 10 * g + 12";
val SOME (t,_) = rewrite_set_ thy false ordne_alphabetisch t; 
if UnparseC.term t = "- 9 + 12 + 5 * e - 7 * e + 6 * f - 4 * f - 8 * g + 10 * g"
then () else error "polyminus.sml: ordne_alphabetisch finished";


"----------- build fasse_zusammen --------------------------------";
"----------- build fasse_zusammen --------------------------------";
"----------- build fasse_zusammen --------------------------------";
val t = str2term "- 9 + 12 + 5 * e - 7 * e + 6 * f - 4 * f - 8 * g + 10 * g";
val SOME (t,_) = rewrite_set_ thy false fasse_zusammen t;
if UnparseC.term t = "3 + -2 * e + 2 * f + 2 * g" then ()
else error "polyminus.sml: fasse_zusammen finished";

"----------- build verschoenere ----------------------------------";
"----------- build verschoenere ----------------------------------";
"----------- build verschoenere ----------------------------------";
val t = str2term "3 + -2 * e + 2 * f + 2 * g";
val SOME (t,_) = rewrite_set_ thy false verschoenere t;
if UnparseC.term t = "3 - 2 * e + 2 * f + 2 * g" then ()
else error "polyminus.sml: verschoenere 3 + -2 * e ...";

(*Rewrite.trace_on := true; ..stopped Test_Isac.thy*)
Rewrite.trace_on:=false;

"----------- met simplification for_polynomials with_minus -------";
"----------- met simplification for_polynomials with_minus -------";
"----------- met simplification for_polynomials with_minus -------";
val str = 
"Program SimplifyScript (t_t::real) =                \
\  (((Try (Rewrite_Set ordne_alphabetisch False)) #>     \
\    (Try (Rewrite_Set fasse_zusammen False)) #>     \
\    (Try (Rewrite_Set verschoenere False))) t_t)"
val sc = (inst_abs o Thm.term_of o the o (parse thy)) str;
atomty sc;

"----------- me simplification.for_polynomials.with_minus";
"----------- me simplification.for_polynomials.with_minus";
"----------- me simplification.for_polynomials.with_minus";
val c = [];
val (p,_,f,nxt,_,pt) = 
      CalcTreeTEST 
        [(["Term (5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12)",
           "normalform N"],
	          ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	           ["simplification", "for_polynomials", "with_minus"]))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
if f2str f = "3 - 2 * e + 2 * f + 2 * g" 
then case nxt of End_Proof' => () | _ =>  error "me simplification.for_polynomials.with_minus 1"
else error "polyminus.sml: me simplification.for_polynomials.with_minus 2";

"----------- pbl polynom vereinfachen p.33 -----------------------";
"----------- pbl polynom vereinfachen p.33 -----------------------";
"----------- pbl polynom vereinfachen p.33 -----------------------";
"----------- 140 c ---";
reset_states ();
CalcTree [(["Term (5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso 
   UnparseC.term (get_obj g_res pt (fst p)) = "3 - 2 * e + 2 * f + 2 * g"
then () else error "polyminus.sml: Vereinfache (3 - 2 * e + 2 * f...";

"======= 140 d ---";
reset_states ();
CalcTree [(["Term (-r - 2*s - 3*t + 5 + 4*r + 8*s - 5*t - 2)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso 
   UnparseC.term (get_obj g_res pt (fst p)) = "3 + 3 * r + 6 * s - 8 * t"
then () else error "polyminus.sml: Vereinfache 140 d)";

"======= 139 c ---";
reset_states ();
CalcTree [(["Term (3*e - 6*f - 8*e - 4*f + 5*e + 7*f)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso 
   UnparseC.term (get_obj g_res pt (fst p)) = "- (3 * f)"
then () else error "polyminus.sml: Vereinfache 139 c)";

"======= 139 b ---";
reset_states ();
CalcTree [(["Term (8*u - 5*v - 5*u + 7*v - 6*u - 3*v)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso 
   UnparseC.term (get_obj g_res pt (fst p)) = "-3 * u - v"
then () else error "polyminus.sml: Vereinfache 139 b)";

"======= 138 a ---";
reset_states ();
CalcTree [(["Term (2*u - 3*v - 6*u + 5*v)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso 
   UnparseC.term (get_obj g_res pt (fst p)) = "-4 * u + 2 * v"
then () else error "polyminus.sml: Vereinfache 138 a)";

"----------- met probe fuer_polynom ------------------------------";
"----------- met probe fuer_polynom ------------------------------";
"----------- met probe fuer_polynom ------------------------------";
val str = 
"Program ProbeScript (e_e::bool) (w_s::bool list) =\
\ (let e_e = Take e_e;                             \
\      e_e = Substitute w_s e_e                    \
\ in (Repeat((Try (Repeat (Calculate ''TIMES''))) #>  \
\            (Try (Repeat (Calculate ''PLUS''))) #>  \
\            (Try (Repeat (Calculate ''MINUS''))))) e_e)"
val sc = (inst_abs o Thm.term_of o the o (parse thy)) str;
atomty sc;

"----------- pbl polynom probe -----------------------------------";
"----------- pbl polynom probe -----------------------------------";
"----------- pbl polynom probe -----------------------------------";
reset_states ();
CalcTree [(["Pruefe ((5::int)*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12 =\
	    \3 - 2 * e + 2 * f + 2 * (g::int))",
	    "mitWert [e = (1::int), f = (2::int), g = (3::int)]",
	    "Geprueft b"],
	   ("PolyMinus",["polynom", "probe"],
	    ["probe", "fuer_polynom"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
(* autoCalculate 1 CompleteCalcHead;
   autoCalculate 1 (Steps 1);
   autoCalculate 1 (Steps 1);
   val ((pt,p),_) = get_calc 1; UnparseC.term (get_obj g_res pt (fst p));
@@@@@WN081114 gives "??.empty", all "Pruefe" are the same,
although analogies work in interface.sml: FIXME.WN081114 in "Pruefe"*)
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso UnparseC.term (get_obj g_res pt (fst p)) = "11 = 11"
then () else error "polyminus.sml: Probe 11 = 11";
Test_Tool.show_pt pt;

"----------- pbl klammer polynom vereinfachen p.34 ---------------";
"----------- pbl klammer polynom vereinfachen p.34 ---------------";
"----------- pbl klammer polynom vereinfachen p.34 ---------------";
reset_states ();
CalcTree [(["Term (2*u - 5 - (3 - 4*u) + (8*u + 9))",
	    "normalform N"],
	   ("PolyMinus",["klammer", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_parentheses"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso 
   UnparseC.term (get_obj g_res pt (fst p)) = "1 + 14 * u"
then () else error "polyminus.sml: Vereinfache (2*u - 5 - (3 - ...";
Test_Tool.show_pt pt;

"======= probe p.34 -----";
reset_states ();
CalcTree [(["Pruefe (2*u - 5 - (3 - 4*u) + (8*u + 9) = 1 + 14 * (u::int))",
	    "mitWert [u = (2::int)]",
	    "Geprueft b"],
	   ("PolyMinus",["polynom", "probe"],
	    ["probe", "fuer_polynom"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso UnparseC.term (get_obj g_res pt (fst p)) = "29 = 29"
then () else error "polyminus.sml: Probe 29 = 29";
Test_Tool.show_pt pt;

"----------- try fun applyTactics --------------------------------";
"----------- try fun applyTactics --------------------------------";
"----------- try fun applyTactics --------------------------------";
reset_states ();
CalcTree [(["Term (5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalcHead;
autoCalculate 1 (Steps 1);
autoCalculate 1 (Steps 1);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
"----- 1 ^^^";
fetchApplicableTactics 1 0 p;
val appltacs = specific_from_prog pt p;
applyTactic 1 p (hd appltacs) (*addiere_x_plus_minus*);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
"----- 2 ^^^";
(*Rewrite.trace_on := true; ..stopped Test_Isac.thy*)
val erls = erls_ordne_alphabetisch;
val t = str2term "- 9 + 12 + 5 * e - 7 * e + (6 - 4) * f - 8 * g + 10 * g";
val SOME (t',_) = 
    rewrite_ (@{theory "Isac_Knowledge"}) e_rew_ord erls false @{thm tausche_minus} t;
UnparseC.term t';     "- 9 + 12 + 5 * e - 7 * e + (- 4 + 6) * f - 8 * g + 10 * g";

val t = str2term "- 9 + 12 + 5 * e - 7 * e + (6 - 4) * f - 8 * g + 10 * g";
val NONE = 
    rewrite_ (@{theory "Isac_Knowledge"}) e_rew_ord erls false @{thm tausche_minus_plus} t;

val t = str2term "- 9 + 12 + 5 * e - 7 * e + (6 - 4) * f - 8 * g + 10 * g";
val SOME (t',_) = 
    rewrite_set_ (@{theory "Isac_Knowledge"}) false ordne_alphabetisch t;
UnparseC.term t';     "- 9 + 12 + 5 * e - 7 * e - 8 * g + 10 * g + (- 4 + 6) * f";
Rewrite.trace_on := false;


applyTactic 1 p (hd (specific_from_prog pt p)) (*tausche_minus*);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
"----- 3 ^^^";
applyTactic 1 p (hd (specific_from_prog pt p)) (**);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
"----- 4 ^^^";
applyTactic 1 p (hd (specific_from_prog pt p)) (**);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
"----- 5 ^^^";
applyTactic 1 p (hd (specific_from_prog pt p)) (**);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
"----- 6 ^^^";

(*<CALCMESSAGE> failure </CALCMESSAGE>
applyTactic 1 p (hd (specific_from_prog pt p)) (**);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
"----- 7 ^^^";
*)
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
(*independent from failure above: met_simp_poly_minus not confluent:
(([9], Res), - (8 * g) + 10 * g + (3 - 2 * e + 2 * f)),
(([], Res), - (8 * g) + 10 * g + (3 - 2 * e + 2 * f))]
~~~~~~~~~~~###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*)


"#############################################################################";
reset_states ();
CalcTree [(["Term (- (8 * g) + 10 * g + h)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso UnparseC.term (get_obj g_res pt (fst p)) = "2 * g + h"
then () else error "polyminus.sml: addiere_vor_minus";


"#############################################################################";
reset_states ();
CalcTree [(["Term (- (8 * g) + 10 * g + f)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso UnparseC.term (get_obj g_res pt (fst p)) = "f + 2 * g"
then () else error "polyminus.sml: tausche_vor_plus";

"----------- pbl binom polynom vereinfachen p.39 -----------------";
"----------- pbl binom polynom vereinfachen p.39 -----------------";
"----------- pbl binom polynom vereinfachen p.39 -----------------";
val rls = klammern_ausmultiplizieren;
val t = str2term "(3 * a + 2) * (4 * a - 1)";
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
"3 * a * (4 * a) - 3 * a * 1 + (2 * (4 * a) - 2 * 1)";
val rls = discard_parentheses;
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
"3 * a * 4 * a - 3 * a * 1 + (2 * 4 * a - 2 * 1)";
val rls = ordne_monome;
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
"3 * 4 * a * a - 1 * 3 * a + (2 * 4 * a - 1 * 2)";
(*
val t = str2term "3 * a * 4 * a";
val rls = ordne_monome;
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
*)
val rls = klammern_aufloesen;
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
"3 * 4 * a * a - 1 * 3 * a + 2 * 4 * a - 1 * 2";
val rls = ordne_alphabetisch;
(*TODO: make is_monom more general, a*a=a^2, ...*)
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
"3 * 4 * a * a - 1 * 2 - 1 * 3 * a + 2 * 4 * a";
(*STOPPED.WN080104
val rls = fasse_zusammen;
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
val rls = verschoenere;
val SOME (t,_) = rewrite_set_ thy false rls t; UnparseC.term t;
*)

(*@@@@@@@*)
reset_states ();
CalcTree [(["Term ((3*a + 2) * (4*a - 1))",
	    "normalform N"],
	   ("PolyMinus",["binom_klammer", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_parentheses_mult"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso 
   UnparseC.term (get_obj g_res pt (fst p)) = "-2 + 12 * a ^^^ 2 + 5 * a"
then () else error "polyminus.sml: Vereinfache (2*u - 5 - (3 - ...";

"----------- pbl binom polynom vereinfachen: cube ----------------";
"----------- pbl binom polynom vereinfachen: cube ----------------";
"----------- pbl binom polynom vereinfachen: cube ----------------";
reset_states ();
CalcTree [(["Term (8*(a - q) + a - 2*q + 3*(a - 2*q))", "normalform N"],
	   ("PolyMinus",["binom_klammer", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_parentheses_mult"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if p = ([], Res) andalso UnparseC.term (get_obj g_res pt (fst p)) = "12 * a - 16 * q" 
then () else error "pbl binom polynom vereinfachen: cube";

"----------- Refine.refine Vereinfache ----------------------------------";
"----------- Refine.refine Vereinfache ----------------------------------";
"----------- Refine.refine Vereinfache ----------------------------------";
val fmz = ["Term (8*(a - q) + a - 2*q + 3*(a - 2*(q::real)))", "normalform (N::real)"];
(*default_print_depth 11;*)
val matches = Refine.refine fmz ["vereinfachen"];
(*default_print_depth 3;*)

"----- go into details, if it seems not to work -----";
"--- does the predicate evaluate correctly ?";
val t = str2term 
	    "matchsub (?a * (?b - ?c)) (8 * (a - q) + a - 2 * q + 3 * (a - 2 * (q::real)))";
val ma = eval_matchsub "" "Prog_Expr.matchsub" t thy;
case ma of
    SOME ("matchsub (?a * (?b - ?c)) (8 * (a - q) + \
	  \a - 2 * q + 3 * (a - 2 * q)) = True", _) => ()
  | _ => error "polyminus.sml matchsub (?a * (?b - ?c)...A";

"--- does the respective prls rewrite ?";
val prls = Rule_Set.append_rules "prls_pbl_vereinf_poly" Rule_Set.empty 
	     [Eval ("Poly.is'_polyexp", eval_is_polyexp ""),
	      Eval ("Prog_Expr.matchsub", eval_matchsub ""),
	      Thm ("or_true",@{thm or_true}),
	      (*"(?a | True) = True"*)
	      Thm ("or_false",@{thm or_false}),
	      (*"(?a | False) = ?a"*)
	      Thm ("not_true",ThmC.numerals_to_Free @{thm not_true}),
	      (*"(~ True) = False"*)
	      Thm ("not_false",ThmC.numerals_to_Free @{thm not_false})
	      (*"(~ False) = True"*)];
(*Rewrite.trace_on := true; ..stopped Test_Isac.thy*)
val SOME (t', _) = rewrite_set_ thy false prls t;
Rewrite.trace_on := false;

"--- does the respective prls rewrite the whole predicate ?";
val t = str2term 
	    "Not (matchsub (?a * (?b + ?c)) (8 * (a - q) + a - 2 * q) | \
	    \     matchsub (?a * (?b - ?c)) (8 * (a - q) + a - 2 * q) | \
	    \     matchsub ((?b + ?c) * ?a) (8 * (a - q) + a - 2 * q) | \
	    \     matchsub ((?b - ?c) * ?a) (8 * (a - q) + a - 2 * q) )";
(*Rewrite.trace_on := true; ..stopped Test_Isac.thy*)
val SOME (t', _) = rewrite_set_ thy false prls t;
Rewrite.trace_on := false;
if UnparseC.term t' = "False" then ()
else error "polyminus.sml Not (matchsub (?a * (?b + ?c)) (8 ...";

"----------- *** Problem.prep_input: syntax error in '#Where' of [v";
"----------- *** Problem.prep_input: syntax error in '#Where' of [v";
"----------- *** Problem.prep_input: syntax error in '#Where' of [v";
(*see test/../termC.sml for details*)
val t = parse_patt thy "t_t is_polyexp";
val t = parse_patt thy ("Not (matchsub (?a + (?b + ?c)) t_t | " ^
	                "     matchsub (?a + (?b - ?c)) t_t | " ^
	                "     matchsub (?a - (?b + ?c)) t_t | " ^
	                "     matchsub (?a + (?b - ?c)) t_t )");
(*show_types := true;
if UnparseC.term t = "~ (matchsub ((?a::real) + ((?b::real) + (?c::real))) (t_t::real) |\n   matchsub (?a + (?b - ?c)) t_t |\n   matchsub (?a - (?b + ?c)) t_t | matchsub (?a + (?b - ?c)) t_t)"
then () else error "polyminus.sml type-structure of \"?a :: real\" changed 1";
show_types := false;*)
if UnparseC.term t =
  "\<not> (matchsub (?a + (?b + ?c)) t_t \<or>\n        " ^
  "matchsub (?a + (?b - ?c)) t_t \<or>\n        " ^
  "matchsub (?a - (?b + ?c)) t_t \<or> " ^
  "matchsub (?a + (?b - ?c)) t_t)"
then () else error "polyminus.sml type-structure of \"?a :: real\" changed 1";

