(* tests for rationals
   Stefan Karnel
   2002
   use"../kbtest/rational.sml";
   use"kbtest/rational.sml";
   use"rational.sml";
*)

(*--------------------------------15.10.02---
(* tests*)
print("\n\n*********************   tests    *************************\n\n");
print("\n\n***** divide tests *****\n");
val mv_pquot1 = (#1(mv_division([(1,[1,1,1]),(1,[1,1,0]),(1,[1,0,1]),(1,[0,0,0])],[(1,[1,1,0]),(1,[0,0,0])],LEX_)));
(* result: [(1,[0,0,1]),(1,[0,0,0])] *)
if mv_pquot1=[(1,[0,0,1]),(1,[0,0,0])] then () else error ("Test failed");

val mv_prest1 = (#2(mv_division([(1,[1,1,1]),(1,[1,1,0]),(1,[1,0,1]),(1,[0,0,0])],[(1,[1,1,0]),(1,[0,0,0])],LEX_)));
(* result: [(1,[1,0,1]),(~1,[0,0,1])] *)
if mv_prest1=[(1,[1,0,1]),(~1,[0,0,1])] then () else error ("Test failed");

val mv_pquot2 = (#1(mv_division([(4,[2]),(8,[1]),(16,[0])],[(1,[1]),(1,[0])],LEX_)));
(* result: [(4,[1]),(4,[0])] *)
if mv_pquot2=[(4,[1]),(4,[0])] then () else error ("Test failed");

val mv_prest2 = (#2(mv_division([(4,[2]),(8,[1]),(16,[0])],[(1,[1]),(1,[0])],LEX_))); 
(* result: [(12,[0]] *)
if mv_prest2=[(12,[0])] then () else error ("Test failed");

val mv_pquot3 = (#1(mv_division([(4,[2]),(~4,[0])],[(2,[1]),(2,[0])],LEX_)));
(* [(2,[1]),(~2,[0])] *)
if mv_pquot3=[(2,[1]),(~2,[0])] then () else error ("Test failed");

val mv_prest3 = (#2(mv_division([(1,[2]),(~1,[0])],[(2,[1]),(2,[0])],LEX_)));
(* [(1,[2]),(~1,[0])] *)
if mv_prest3=[(1,[2]),(~1,[0])] then () else error ("Test failed");

val mv_pquot4 = (#1(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1])],[(2,[1,0,0]),(4,[0,0,1])],LEX_)));
(* [(1,[0,1,1])] *)
if mv_pquot4=[(1,[0,1,1])] then () else error ("Test failed");

val mv_prest4 = (#2(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1])],[(2,[1,0,0]),(4,[0,0,1])],GGO_)));
(* [(1,[1,1,1]),(~4,[0,1,2]),(4,[1,0,1]),(3,[0,0,1])] *)
if mv_prest4 =[(1,[1,1,1]),(~4,[0,1,2]),(4,[1,0,1]),(3,[0,0,1])] then () else error ("Test failed");

val mv_pquot5 = (#1(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1]),(6,[2,1,3]),(4,[0,4,1]),(1,[2,2,1])],[(1,[0,0,1])],LEX_))); 
(* [(1,[2,2,0]),(6,[2,1,2]),(3,[1,1,0]),(4,[1,0,0]),(4,[0,4,0]),(3,[0,0,0])]*)
if mv_pquot5=[(1,[2,2,0]),(6,[2,1,2]),(3,[1,1,0]),(4,[1,0,0]),(4,[0,4,0]),(3,[0,0,0])] then () else error ("Test failed");

val mv_prest5 = (#2(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1]),(6,[2,1,3]),(4,[0,4,1]),(1,[2,2,1])],[(1,[0,0,1])],LEX_)));
(* [] *)
if mv_prest5=[] then () else error ("Test failed");

(* (x^2 + 2(a+1)x + (a^2+2a+1)) / (x+a+1) = x+a+1 *)
val mv_pquot6 = (#1(mv_division([(1,[2,0,0]),(2,[1,1,0]),(2,[1,0,0]),(1,[0,2,0]),(2,[0,1,0]),(1,[0,0,0])],[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])],LEX_)));
if mv_pquot6=[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])] then () else error ("Test failed");

val mv_prest6 = (#2(mv_division([(1,[2,0,0]),(2,[1,1,0]),(2,[1,0,0]),(1,[0,2,0]),(2,[0,1,0]),(1,[0,0,0])],[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])],LEX_)));
if mv_prest6=[] then () else error ("Test failed");

(* Exception tests *)
(* mv_division ([(1,[0,0,0])],[(0,[1,2,3])],LEX_); *)

print("\n\n***** MV_CONTENT-TESTS *****\n");
val mv_cont1=mv_content([(1,[2,1]),(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,1]),(1,[0,0])]); 
(* [(1,[0,1]),(1,[0,0])] *)
if  mv_cont1=[(1,[0,1]),(1,[0,0])] then () else error ("Test failed");

val mv_pp1=mv_pp([(1,[1,1]),(1,[1,0]),(1,[0,1]),(1,[0,0])]); 
(*[(1,[1,0]),(1,[0,0])]*)
if mv_pp1=[(1,[1,0]),(1,[0,0])] then () else error ("Test failed");

val mv_cont2=mv_content([(2,[1]),(4,[0])]);
(* [(2,[0])] *)
if mv_cont2=[(2,[0])] then () else error ("Test failed");

val mv_pp2=mv_pp([(2,[1]),(4,[0])]);
(* [(1,[1]),(2,[0])] *)
if mv_pp2=[(1,[1]),(2,[0])] then () else error ("Test failed");

val mv_cont3=mv_content[(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(16,[1,1,1])];
(* [(2,[0,0,0])] *)
if mv_cont3=[(2,[0,0,0])] then () else error ("Test failed");

val mv_pp3=mv_pp[(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(16,[1,1,1])];
(* [(5,[2,2,0]),(4,[2,1,1]),(8,[1,1,1]),(6,[1,0,2])] *)
if mv_pp3=[(5,[2,2,0]),(4,[2,1,1]),(8,[1,1,1]),(6,[1,0,2])] then () else error ("Test failed");

val mv_cont4=mv_content[(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(1,[0,0,0])] *)
if mv_cont4=[(1,[0,0,0])] then () else error ("Test failed");

val mv_pp4=mv_pp [(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])]; 
(* [(2,[2,1,0]),(2,[1,1,0]),(3,[1,0,1]),(3,[0,0,1])] *)
if mv_pp4=[(2,[2,1,0]),(2,[1,1,0]),(3,[1,0,1]),(3,[0,0,1])] then () else error ("Test failed");

val con1=mv_content([(9,[2,0]),(15,[1,1]),(12,[1,0]),(6,[0,2]),(12,[0,1])]);
(* [(3,[0,0])] *) 
if con1=[(3,[0,0])] then () else error ("Test failed");

val pp1=mv_pp([(9,[2,0]),(15,[1,1]),(12,[1,0]),(6,[0,2]),(12,[0,1])]);
(* [(3,[2,0]),(5,[1,1]),(4,[1,0]),(2,[0,2]),(4,[0,1])] *) 
if pp1=[(3,[2,0]),(5,[1,1]),(4,[1,0]),(2,[0,2]),(4,[0,1])] then () else error ("Test failed");

val con2=mv_content([(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])]); 
(* [(1,[0,0])] *)
if con2=[(1,[0,0])] then () else error ("Test failed");

val pp2 =mv_pp([(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])]); 
(* [(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])] *)
if pp2=[(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])] then () else error ("Test failed");

val cont1 = mv_content [(1,[2,1,0]),(2,[2,1,0])]; 
(* [(3,[0,1,0])] *)
if cont1=[(3,[0,1,0])] then () else error ("Test failed");

val pp1 = mv_pp [(1,[2,1,0]),(2,[2,1,0])]; 
(* [(1,[2,0,0])] *)
if pp1=[(1,[2,0,0])] then () else error ("Test failed");

val cont2 = mv_content [(4,[1,2,0]),(2,[2,1,0])]; 
(* [(2,[0,1,0])] *)
if cont2=[(2,[0,1,0])] then () else error ("Test failed");

val pp2 = mv_pp [(4,[1,2,0]),(2,[2,1,0])];
(* [(1,[2,0,0]),(2,[1,1,0])] *)
if pp2=[(1,[2,0,0]),(2,[1,1,0])] then () else error ("Test failed");

print("\n\n\n\n********************************************************\n\n");
val cont3=mv_content [(65,[3,2,2]),(52,[3,2,1]),(26,[3,1,2]),(~95,[2,2,3]),(~76,[2,2,2]),(35,[2,2,1]),(28,[2,2,0]),(~38,[2,1,3]),(14,[2,1,1])];
(*if cont3=[(1,[0,1,0])] then () else error ("Test failed"); *)
val pp3=mv_pp [(65,[3,2,2]),(52,[3,2,1]),(26,[3,1,2]),(~95,[2,2,3]),(~76,[2,2,2]),(35,[2,2,1]),(28,[2,2,0]),(~38,[2,1,3]),(14,[2,1,1])];


print("\n\n***** gcd-tests *****\n"); 
val ggt1 = gcd_poly [(4,[2,2]),(8,[1,1]),(4,[0,0])] [(2,[1,1]),(2,[0,0])]; 
(* [(2,[1,1]),(2,[0,0])] *)
if ggt1=[(2,[1,1]),(2,[0,0])] then () else error ("Test failed");

val ggt2 = gcd_poly [(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(15,[1,1,1])] [(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(2,[1,1,0]),(3,[0,0,1])] *)
if ggt2=[(2,[1,1,0]),(3,[0,0,1])] then () else error ("Test failed");

val ggt3 = gcd_poly [(1,[2,0,0]),(~2,[1,0,1]),(1,[0,0,2])] [(1,[1,0,0]),(~1,[0,0,1])]; 
(* [(1,[1,0,0]),(~1,[0,0,1])] *)
if ggt3=[(1,[1,0,0]),(~1,[0,0,1])] then () else error ("Test failed");

val ggt4 = gcd_poly [(1,[2,1,0]),(2,[2,1,0])] [(5,[1,0,0])]; 
(* [(1,[1,0,0])] *)
if ggt4=[(1,[1,0,0])] then () else error ("Test failed");

val ggt5 = gcd_poly [(4,[2,0,0]),(~8,[1,0,1]),(4,[0,0,2])] [(1,[2,0,0]),(~1,[0,0,2])]; 
(* [(1,[1,0,0]),(~1,[0,0,1])] *)
if ggt5=[(1,[1,0,0]),(~1,[0,0,1])] then () else error ("Test failed");

val ggt6 = gcd_poly [(10,[2,1,1]),(14,[1,1,0]),(3,[1,0,1]),(20,[1,2,1])] [(5,[1,1,1]),(7,[2,1,1])];
(* [(1,[0,0,0])] *)
if ggt6=[(1,[1,0,0])] then () else error ("Test failed");

val ggt7 = gcd_poly [(~169,[4,3,3]),(273,[4,2,2]),(247,[3,3,4]),(~91,[3,3,2]),(78,[3,3,1]),(~399,[3,2,3]),(147,[3,2,1]),(~114,[2,3,2]),(42,[2,3,0])]  [(65,[3,2,2]),(52,[3,2,1]),(26,[3,1,2]),(~95,[2,2,3]),(~76,[2,2,2]),(35,[2,2,1]),(28,[2,2,0]),(~38,[2,1,3]),(14,[2,1,1])];
(* [(13,[3,1,1]),(~19,[2,1,2]),(7,[2,1,0])] *)
if ggt7=[(13,[3,1,1]),(~19,[2,1,2]),(7,[2,1,0])] then () else error ("Test failed");

print("\n\n***** kgv-tests *****\n"); 
val kgv1=lcm_poly [(10,[])] [(15,[])];
(* [(30,[])] *)
if kgv1=[(30,[])] then () else error ("Test failed");

val kgv2=lcm_poly [(1,[2,0,0]),(~2,[1,0,1]),(1,[0,0,2])] [(1,[1,0,0]),(~1,[0,0,1])]; 
(* [(1,[2,0,0]),(~2,[1,0,1]),(1,[0,0,2])] *)
if kgv2=[(1,[2,0,0]),(~2,[1,0,1]),(1,[0,0,2])] then () else error ("Test failed");

val kgv3=lcm_poly [(4,[2,0,0]),(~8,[1,0,1]),(4,[0,0,2])] [(1,[2,0,0]),(~1,[0,0,2])]; 
(* [(4,[3,0,0]),(~4,[2,0,1]),(~4,[1,0,2]),(4,[0,0,3])] *)
if kgv3=[(4,[3,0,0]),(~4,[2,0,1]),(~4,[1,0,2]),(4,[0,0,3])] then () else error ("Test failed");

(*
print("***** TERM2POLY-TESTS *****\n"); 
val t0 = (Thm.term_of o the o (parse thy)) "3 * 4";
val t1 = (Thm.term_of o the o (parse thy)) "27";
val t11= (Thm.term_of o the o (parse thy)) "27 * c";
val t2 = (Thm.term_of o the o (parse thy)) "b";
val t23= (Thm.term_of o the o (parse thy)) "c^^^7";
val t24= (Thm.term_of o the o (parse thy)) "5 * c^^^7";
val t26= (Thm.term_of o the o (parse thy)) "a * b"; 
val t3 = (Thm.term_of o the o (parse thy)) "2  +  a";
val t4 = (Thm.term_of o the o (parse thy)) "b  +  a";
val t5 = (Thm.term_of o the o (parse thy)) "2  +  a^^^3";*)
val t6 = (Thm.term_of o the o (parse thy)) "5*a^^^2*b^^^3*c+4*a^^^4*b+2*a*c";
val t7 = (Thm.term_of o the o (parse thy)) "a-b";
(*
(the o term2poly) t0;
(the o term2poly) t1;
(the o term2poly) t11;
(the o term2poly) t2;
(the o term2poly) t23;
(the o term2poly) t24;
(the o term2poly) t26;
(the o term2poly) t3;
(the o term2poly) t4;
(the o term2poly) t5;
(the o term2poly) t6;
(the o term2poly) t7;*)


print("\n\n***** STEP_CANCEL_TESTS: *****\n");
(*
val term2 = (Thm.term_of o the o (parse thy)) " (9 * a^^^2 * b) ///  (6 * a * c)";
val div2   = step_cancel term2;
atomt div2; 
*)

val term1 = (Thm.term_of o the o (parse thy)) "(10 * a^^^2 * b * c + 14 * a * b + 3 * a * c + 20 * a * b^^^2 * c) /// a";
val div1  = step_cancel term1;
(*if div1 =  (Thm.term_of o the o (parse thy)) "((10 * a * b * c + 14 * b + 3 * c + 20 * b^^^2 * c) * a) /// (1 * a)" then () else raise error ("Test failed");*)

val term2 = (Thm.term_of o the o (parse thy)) "(10 * a^^^2 * b * c + 14 * a * b + 3 * a * c + 20 * a * b^^^2 * c) /// (5 * a * b * c  +  7 * a^^^2 * b * c) ";
val div2  = step_cancel term2;
(*if div2 = ([(10,[1,1,1]),(20,[0,2,1]),(14,[0,1,0]),(3,[0,0,1])],[(1,[1,0,0])],[(7,[1,1,1]),(5,[0,1,1])]) then () else raise error ("Test failed");*)


val term3 = (Thm.term_of o the o (parse thy)) "(10 * a^^^2 * b * c) /// (1 * x * y * z) ";
val div3 = step_cancel term3;



(*val mul1=(Thm.term_of o the o (parse thy)) "(5*a*b*c+4*a*b+2*a*c)"; 
val mul2=(the (term2poly((Thm.term_of o the o (parse thy)) "13*a^^^2*b*c+7*a*b-19*a*b*c^^^2")));
val mul3=(the (term2poly((Thm.term_of o the o (parse thy)) "6*a*b^^^2-13*a^^^2*b^^^2*c^^^2+21*a^^^2*b*c")));
val t1=mv_mul(mul1,mul2,LEX_);
val t2=mv_mul(mul3,mul2,LEX_);
val div3=step_cancel t1 t2;
if div3=([(5,[0,1,1]),(4,[0,1,0]),(2,[0,0,1])],[(13,[3,1,1]),(~19,[2,1,2]),(7,[2,1,0])],[(~13,[1,2,2]),(21,[1,1,1]),(6,[0,2,0])]) then () else error ("Test failed");*)

print("\n\n***** all tests successfull ;-) ******\n\n");



val thy = Rational.thy;
val rls = Prls {func=cancel};
val t = (Thm.term_of o the o (parse thy)) 
	    "(1 + 1 * a ^^^ 1)///(-2 + 2 * a ^^^ 2)";
val (t,asm) = the (rewrite_set_ thy eval_rls false rls t);


val thy' = "Rational";
val rls' = "cancel";
val t' = "(1 + 1 * a ^^^ 1)///(-2 + 2 * a ^^^ 2)";
val (t',asm') = the (rewrite_set thy' "eval_rls" false rls' t');
(*if t' = "1 /// (-2 + 2 * a)" then ()
else error "tests/rationals.sml(1): new behaviour";*)


val thy' = "Rational";
val rls' = "cancel";
val t' = "(10 * a^^^2 * b * c + 14 * a * b + 3 * a * c + 20 * a * b^^^2 * c) /// (5 * a * b * c  +  7 * a^^^2 * b * c) ";
val (t',asm') = the (rewrite_set thy' "eval_rls" false rls' t');

val thy' = "Rational";
val rls' = "cancel";
val t' = "(a^^^2 * b  + 2 * a * b +  b ) /// ( a^^^2   - 1 )";
val (t',asm') = the (rewrite_set thy' "eval_rls" false rls' t');

(*
val term2 = (Thm.term_of o the o (parse thy))  "(a^^^2 * b  + 2 * a * b +  b ) /// ( a^^^2   - 1 )";
val div2  = direct_cancel term2;
val t = (Thm.term_of o the o (parse thy)) "(1 + 1 * a ^^^ 1)///(-2 + 2 * a ^^^ 2) = 0";*)



(*WN folgendes aus examples he"uberkopiert ...*)

(* examples from:
   Mathematik 1
   Schalk 
   Reniets Verlag *)

val thy' = "Rational";
val rls' = "cancel";
val mp = "make_polynomial";

(* page 63 *)

print("\n\nexample 186:\n");
print("a)\n");
val e186a'="(14 * x * y) / ( x * y )";
val e186a = the (rewrite_set thy' "rational_erls" false rls' e186a');
print("b)\n");
val e186b'="(60 * a * b) / ( 15 * a  * b )";
val e186b = the (rewrite_set thy' "rational_erls" false rls' e186b');
print("c)\n");
val e186c'="(144 * a^^^2 * b * c) / (12 * a * b * c )";
val e186c = (the (rewrite_set thy' "rational_erls" false rls' e186c'))
    handle e => OldGoals.print_exn e;
val t = (Thm.term_of o the o (parse thy)) e186c';
atomt t;

print("\n\nexample 187:\n");
print("a)\n");
val e187a'="(12 * x * y) / (8 * y^^^2 )";
val e187a = the (rewrite_set thy' "rational_erls" false rls' e187a');
print("b)\n");
val e187b'="(8 * x^^^2 * y * z ) / (18 * x * y^^^2 * z )";
val e187b = the (rewrite_set thy' "rational_erls" false rls' e187b');
print("c)\n");
val e187c'="(9 * x^^^5 * y^^^2 * z^^^4) / (15 * x^^^6 * y^^^3 * z )";
val e187c = the (rewrite_set thy' "rational_erls" false rls' e187c');

print("\n\nexample 188:\n");
print("a)\n");
val e188a'="(8 * x + -8) / (9 * x + -9 )";
val e188a = the (rewrite_set thy' "rational_erls" false rls' e188a');
val SOME (t,_) = rewrite_set thy' "rational_erls" false mp "(8*((-1) + x))/(9*((-1) + x))";
if t="((-8) + 8 * x) / ((-9) + 9 * x)"then()
else error "rationals.sml: e188a new behaviour";
print("b)\n");
val e188b'="(5 * x + -15) / (6 * x + -18 )";
val e188b = the (rewrite_set thy' "rational_erls" false rls' e188b');
print("c)\n");
val e188c'="( a + -1 * b ) / ( b + -1 * a )";
val e188c = the (rewrite_set thy' "rational_erls" false rls' e188c');
val SOME (t,_) = rewrite_set thy' "rational_erls" false mp "((-1)*(b + (-1) * a))/(1*(b + (-1) * a))";
if t="(a + -1 * b) / (b + -1 * a)"then()
else error "rationals.sml: e188c new behaviour";

print("\n\nexample 190:\n");
print("c)\n");
val e190c'="( 27 * a^^^3 + 9 * a^^^2 + 3 * a + 1 ) / ( 27 * a^^^3 + 18 * a^^^2 + 3 * a )";
val e190c = the (rewrite_set thy' "rational_erls" false rls' e190c');
val SOME (t,_) = rewrite_set thy' "rational_erls" false mp "((1 + 9 * a ^^^ 2)*(1 + 3 * a))/((3 * a + 9 * a ^^^ 2)*(1 + 3 * a))";
if t="(1 + (3 * a + (27 * a ^^^ 3 + 9 * a ^^^ 2))) /\n(3 * a + (18 * a ^^^ 2 + 27 * a ^^^ 3))"then()
(*TERMORDER               ~~~~~~~       ~~~~~~~*)
else error "rationals.sml: e190c new behaviour";

print("\n\nexample 191:\n");
print("a)\n");
val e191a'="( x^^^2 + -1 * y^^^2 ) / ( x + y )";
val e191a = the (rewrite_set thy' "rational_erls" false rls' e191a'); 
val SOME (t,_) = rewrite_set thy' "rational_erls" false mp "((x + (-1) * y)*(x + y))/((1)*(x + y))";
if t="(x ^^^ 2 + -1 * y ^^^ 2) / (x + y)"then()
else error "rationals.sml: e191a new behaviour";
print("c)\n");
val e191c'="( 9 * x^^^2 + -30 * x + 25 ) / ( 9 * x^^^2 + -25 )";
val e191c = the (rewrite_set thy' "rational_erls" false rls' e191c');
val SOME (t,_) = rewrite_set thy' "rational_erls" false mp "(((-5) + 3 * x)*((-5) + 3 * x))/((5 + 3 * x)*((-5) + 3 * x))";
if t="(25 + ((-30) * x + 9 * x ^^^ 2)) / ((-25) + 9 * x ^^^ 2)"then()
else error "rationals.sml: 'e191c' new behaviour";

print("\n\nexample 192:\n");
print("b)\n");
val e192b'="( 7 * x^^^3 + -1 * x^^^2 * y ) / ( 7 * x * y^^^2 + -1 *  y^^^3 )";
val e192b = the (rewrite_set thy' "rational_erls" false rls' e192b');
val SOME (t,_) = rewrite_set thy' "rational_erls" false mp "((x ^^^ 2)*(7 * x + (-1) * y))/((y ^^^ 2)*(7 * x + (-1) * y))";
if t="(7 * x ^^^ 3 + -1 * (y * x ^^^ 2)) / (-1 * y ^^^ 3 + 7 * (x * y ^^^ 2))"then()
(*TERMORDER                ~~~~~*)
else error "rationals.sml: 'e192b' new behaviour";

print("\n\nexample 193:\n");
print("a)\n");
val e193a'="( x^^^2 + -6 * x + 9 ) / ( x^^^2 + -9 )";
val e193a = the (rewrite_set thy' "rational_erls" false rls' e193a');
print("b)\n");
val e193b'="( x^^^2 + -8 * x + 16 ) / ( 2 * x^^^2 + -32 )";
val e193b = the (rewrite_set thy' "rational_erls" false rls' e193b');
print("c)\n");
val e193c'="( 2 * x + -50 * x^^^3 ) / ( 25 * x^^^2 + -10 * x + 1 )";
val SOME(t,_) = rewrite_set thy' "rational_erls" false rls' e193c';
--------------------------------15.10.02---*)


(*---------- WN: 10.9.02:
ML> val e204a = the (rewrite_set thy' "rational_erls" false rls' e204a');
*** RATIONALS_STEP_CANCEL_EXCEPTION: Invalid fraction                           
print("\n\nexample 204:\n");
print("a)\n");
val e204a'="((5 * x) / 9) + ((3 * x) / 9) + (x / 9)";
val e204a = the (rewrite_set thy' "rational_erls" false rls' e204a');
print("b)\n");
val e204b'="5 / x + -3 / x + -1 / x";
val e204b = the (rewrite_set thy' "rational_erls" false rls' e204b');

print("\n\nexample 205:\n");
print("a)\n");
val e205a'="((4 * x + 7) / 8) + ((4 * x + 3) / 8)";
val e205a = the (rewrite_set thy' "rational_erls" false rls' e205a');
print("b)\n");
val e205b'="((5 * x + 2) / 3) + ((-2 * x + 1) / 3)";
val e205b = the (rewrite_set thy' "rational_erls" false rls' e205b');

print("\n\nexample 206:\n");
print("a)\n");
val e206a'="((5 * x + 4) / (2 * x + -1)) + ((9 * x + 5) / (2 * x + -1))";
val e206a = the (rewrite_set thy' "rational_erls" false rls' e206a'); 
print("b)\n");
val e206b'="((17 * x + -23) / (5 * x + 4)) + ((-25 + -17 * x) / (5 * x + 4))";
val e206b = the (rewrite_set thy' "rational_erls" false rls' e206b');

print("\n\nexample 207:\n");
val e207'="((3 * x * y + 3 * y) / (x * y)) + ((5 * x * y + 7 * y) / (x * y)) + ((9 * x * y + -2 * y) / (x * y)) + ((x * y + 4 * y) / (x * y)) ";
val e207 = the (rewrite_set thy' "rational_erls" false rls' e207'); 

print("\n\nexample 208:\n");
val e208'="((3 * x + 2) / (x + 2)) + ((5 * x + -1) / (x + 2)) + ((-7 * x + -3) / (x + 2)) + ((-1 * x + -3) / (x + 2)) ";
val e208 = the (rewrite_set thy' "rational_erls" false rls' e208'); 

print("\n\nexample 209:\n");
val e209'="((3 * x + -7 * y + 3 * z) / (4)) + ((2 * x + 17 * y + 10 * z) / (4)) + ((-1 * x + 2 * y + z) / (4)) ";
val e209 = the (rewrite_set thy' "rational_erls" false rls' e209'); 

print("\n\nexample 210:\n");
val e210'="((2 * x + 3 +  -1 * x^^^2) / (5 * x)) + ((5 * x^^^2 + -2 * x + 1) / (5 * x)) + ((-3 * x^^^2 + -2 * x + 1) / (5 * x)) + ((-1 * x^^^2 + -3 * x + -5) / (5 * x)) ";
val e210 = the (rewrite_set thy' "rational_erls" false rls' e210'); 

print("\n\nexample 211:\n");
print("a)\n"); 
val e211a'="((b) / (a + -1 * b)) + ((-1 * a) / (a + -1 * b))"; 
val e211a = the (rewrite_set thy' "rational_erls" false rls' e211a'); 
print("b)\n");
val e211b'="((b) / (b^^^2 + -1 * a^^^2)) + ((-1 * a) / (b^^^2 + -1 * a^^^2))";
val e211b = the (rewrite_set thy' "rational_erls" false rls' e211b');

print("\n\nexample 212:\n");
print("a)\n");
val e212a'="((4) / (x)) + ((-3) / (y)) + -1";
val e212a = the (rewrite_set thy' "rational_erls" false rls' e212a'); 
print("b)\n");
val e212b'="((4) / (x)) + ((-5) / (y)) + ((6) / (x*y))";
val e212b = the (rewrite_set thy' "rational_erls" false rls' e212b');

print("\n\nexample 213:\n");
print("a)\n"); 
val e213a'="((5 * x) / (3 * y^^^2)) + ((19 * z) / (6 * x * y)) +  ((-2 * x) / (3 * y^^^2)) + ((7 * y^^^2) / (6 * x^^^2)) ";
val e213a = the (rewrite_set thy' "rational_erls" false rls' e213a'); 
print("b)\n"); 
val e213b'="((2 * b) / (3 * a^^^2)) + ((3 * c) / (7 * a * b)) +  ((4 * b) / (3 * a^^^2)) + ((3 * a) / (7 * b^^^2))";
val e213b = the (rewrite_set thy' "rational_erls" false rls' e213b');

print("\n\nexample 214:\n");
print("a)\n");
val e214a'="((3 * x + 2 * y + 2 * z) / (4)) + ((-5 * x + -3 * y) / (3)) + ((x + y + -2 * z) / (2))";
val e214a = the (rewrite_set thy' "rational_erls" false rls' e214a'); 
print("b)\n");
val e214b'="((5 * x + 2 * y + z) / (2)) + ((-7 * x + -3 * y) / (3)) + ((3 * x + 6 * y + -1 * z) / (12))";
val e214b = the (rewrite_set thy' "rational_erls" false rls' e214b');

print("\n\nexample 216:\n");
print("a)\n"); 
val e216a'="((2 * b + 3 * c) / (a * c)) + ((3 * a + b) / (a * b)) + ((-2 * b^^^2 + -3 * a * c) / (a * b * c))";
val e216a = the (rewrite_set thy' "rational_erls" false rls' e216a');  
print("b)\n");
val e216b'="((2 * a + 3 * b) / (b * c)) + ((3 * c + a) / (a * c)) + ((-2 * a^^^2 + -3 * b * c) / (a * b * c))";
val e216b = the (rewrite_set thy' "rational_erls" false rls' e216b');

print("\n\nexample 217:\n");
val e217'="((z + -1) / (z)) + ((3 * z ^^^2 + -6 * z + 5) / (z^^^2)) + ((-4 * z^^^3 + 7 * z^^^2 + -5 * z + 5) / (z^^^3))";
val e217 = the (rewrite_set thy' "rational_erls" false rls' e217'); 

print("\n\nexample 218:\n");
val e218'="((9 * a^^^3 - 5 * a^^^2 + 2 * a + 8) / (108 * a^^^4)) + ((-5 * a + 3 * a^^^2 + 4) / (8 * a^^^3)) + ((-261 * a^^^3 + 19 * a^^^2 + -112 * a + 16) / (216 * a^^^4))";
val e218 = the (rewrite_set thy' "rational_erls" false rls' e218'); 

print("\n\nexample 219:\n");
print("a)\n");
val e219a'="((1) / (y + 1)) + ((1) / (y + 2)) + ((1) / (y + 3))";
val e219a = the (rewrite_set thy' "rational_erls" false rls' e219a');
print("b)\n");
val e219b'="((1) / (x + 1)) + ((1) / (x + 2)) + ((-2) / (x + 3))";
val e219b = the (rewrite_set thy' "rational_erls" false rls' e219b'); 

print("\n\nexample 220:\n");
print("a)\n");
val e220a'="((17) / (5 * r + -2)) + ((-13) / (2 * r + 3)) + ((4) / (3 * r + -5))";
val e220a = the (rewrite_set thy' "rational_erls" false rls' e220a');
print("b)\n");
val e220b'="((20 * a) / (a + -3)) + ((-19 * a) / (a + -4)) + ((a) / (a + -5))";
val e220b = the (rewrite_set thy' "rational_erls" false rls' e220b'); 

print("\n\nexample 221:\n");
print("a)\n");
val e221a'="((a + b) / (a + -1 * b)) + ((a + -1 * b) / (a + b))";
val e221a = the (rewrite_set thy' "rational_erls" false rls' e221a');
print("b)\n");
val e221b'="((x + -1 * y) / (x + y)) + ((x + y) / (x + -1 * y)) ";
val e221b = the (rewrite_set thy' "rational_erls" false rls' e221b');

print("\n\nexample 222:\n");
print("a)\n");
val e222a'="((1 + -1 * x) / (1 + x)) + ((-1 + -1 * x) / (1 + -1 * x)) + ((4 * x) / (1 + -1 * x^^^2))";
val e222a = the (rewrite_set thy' "rational_erls" false rls' e222a');
print("b)\n");
val e222b'="((1 + x ) / (1 + -1 * x)) + ((-1 + x) / (1 + x)) + ((2 * x) / (1 + -1 * x^^^2))";
val e222b = the (rewrite_set thy' "rational_erls" false rls' e222b'); 

print("\n\nexample 225:\n");
print("a)\n");
val e225a'="((6 * a) / (a^^^2 + -64)) + ((a + 2) / (2 * a + 16)) + ((-1) / (2))";
val e225a = the (rewrite_set thy' "rational_erls" false rls' e225a');
print("b)\n");
val e225b'="((a + 2 ) / (2 * a + 12)) + ((4 * a) / (a^^^2 + -36)) + ((-1) / (2))";
val e225b = the (rewrite_set thy' "rational_erls" false rls' e225b'); 

print("\n\nexample 226:\n");
print("a)\n");
val e226a'="((35 * z) / (49 * z^^^2 + -4)) + -1 + ((14 * z + -1) / (14 * z + 4)) ";
val e226a = the (rewrite_set thy' "rational_erls" false rls' e226a');
print("b)\n"); 
val e226b'="((45 * a * b) / (25 * a^^^2 + -9 * b^^^2)) + ((20 * a + 3 * b) / (10 * a + 6 * b))  + -2";
val e226b = the (rewrite_set thy' "rational_erls" false rls' e226b');  

print("\n\nexample 227:\n");
print("a)\n");
val e227a'="((6 * z + 11) / (6 * z + 14)) + ((9 * z ) / (9 * z^^^2 + -49)) + -1 ";
val e227a = the (rewrite_set thy' "rational_erls" false rls' e227a');
print("b)\n");
val e227b'="((16 * a + 37 * b) / (4 * a + 10 * b)) + ((6 * a * b) / (4 * a^^^2 + -25 * b^^^2)) + -4 ";
val e227b = the (rewrite_set thy' "rational_erls" false rls' e227b'); 

print("\n\nexample 228:\n");
print("a)\n");
val e228a'="((7 * a + 11) / (3 * a^^^2 + -3)) + ((-2 * a + -1) / (a^^^2 + -1 * a)) + ((-1) / (3 * a + 3))";
val e228a = the (rewrite_set thy' "rational_erls" false rls' e228a'); 
print("b)\n");
val e228b'="((11 * z + 2 * b) / (4 * b * z + -8 * b^^^2)) + ((-8 * z) / (z^^^2 + -4 * b^^^2)) + ((-9 * z + -2 * b) / (4 * b * z + 8 * b^^^2))";
val e228b = the (rewrite_set thy' "rational_erls" false rls' e228b');  


print("\n\nexample 229:\n");
print("a)\n");
val e229a'="((5 * x^^^2 + y) / (x + 2 * y)) + ((-8 * x^^^3 + 4 * x^^^2 * y + 3 * x * y) / (x^^^2 + -4 * y^^^2)) + ((3 * x^^^2 + -4 * y) / (x + -2 * y))";
val e229a = the (rewrite_set thy' "rational_erls" false rls' e229a'); 
print("b)\n");
val e229b'="((7 * x^^^2 + y) / (x + 3 * y)) + ((-24 * x^^^2 * y + 5 * x * y + 21 * y^^^2) / (x^^^2 + -9 * y^^^2)) + ((4 * x^^^2 + -6 * y) / (x + -3 * y))"; 
val e229b = the (rewrite_set thy' "rational_erls" false rls' e229b'); 
 
print("\n\nexample 230:\n");
print("a)\n"); 
val e230a'="((5 * x^^^2 + y) / (2 * x + y)) + ((-16 * x^^^3 + 2 * x^^^2 * y + 6 * x * y) / (4 * x^^^2 + -1 * y^^^2)) + ((3 * x^^^2 + -4 * y) / (2 * x + -1 * y))";
val e230a = the (rewrite_set thy' "rational_erls" false rls' e230a');
print("b)\n");
val e230b'="((7 * x^^^2 + y) / (3 * x + y)) + ((-3 * x^^^3  + 15 * x * y + -7 * x^^^2 * y + 7 * y^^^2) / (9 * x^^^2 + -1 * y^^^2)) + ((4 * x^^^2 + -6 * y) / (3 * x + -1 * y))";
val e230b = the (rewrite_set thy' "rational_erls" false rls' e230b');

print("\n\nexample 231:\n");
print("a)\n");
val e231a'="((2 * x + 5 * y) / (x)) + ((2 * x^^^3 + -5 * y^^^3 + 3 * x * y^^^2) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-3 * x + -6 * y) / (x + -1 * y))";
val e231a = the (rewrite_set thy' "rational_erls" false rls' e231a'); 
print("b)\n");
val e231b'="((6 * x + 2 * y) / (x)) + ((6 * x^^^2 * y + -4 * x * y^^^2 + -2 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-5 * x + -3 * y) / (x + -1 * y))";
val e231b = the (rewrite_set thy' "rational_erls" false rls' e231b');

print("\n\nexample 232:\n");
print("a)\n");
val e232a'="((2 * x + 3 * y) / (x)) + ((4 * x^^^3 + -1 * x * y^^^2 + -3 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-5 * x + -6 * y) / (x + -1 * y))";
val e232a = the (rewrite_set thy' "rational_erls" false rls' e232a'); 
print("b)\n");
val e232b'="((5 * x + 2 * y) / (x)) + ((2 * x^^^3 + -3 * x * y^^^2 + 3 * x^^^2 * y + -2 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-6 * x + -3 * y) / (x + -1 * y))";
val e232b = the (rewrite_set thy' "rational_erls" false rls' e232b');

print("\n\nexample 233:\n");
print("a)\n");
val e233a'="((5 * x + 6 * y) / (x)) + ((5 * x * y^^^2 + -6 * y^^^3 + -2 * x^^^3 + 3 * x^^^2 * y) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-2 * x + -3 * y) / (x + -1 * y))";
val e233a = the (rewrite_set thy' "rational_erls" false rls' e233a'); 
print("b)\n");
val e233b'="((6 * x + 5 * y) / (x)) + ((4 * x^^^2 * y + 3 * x * y^^^2 + -5 * y^^^3 + -2 * x^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-3 * x + -2 * y) / (x + -1 * y))";
val e233b = the (rewrite_set thy' "rational_erls" false rls' e233b');

print("\n\nexample 234:\n");
print("a)\n");
val e234a'="((5 * a + b) / (2 * a * b + -2 * b^^^2)) + ((-3 * a + -1 * b) / (2 * a * b + 2 * b^^^2)) + ((-2 * a) / (a^^^2 + -1 * b^^^2))";
val e234a = the (rewrite_set thy' "rational_erls" false rls' e234a'); 
print("b)\n"); 
val e234b'="((5 * a + 3 * b) / (6 * a * b + -18 * b^^^2)) + ((-3 * a + -3 * b) / (6 * a * b + 18 * b^^^2)) + ((-2 * a) / (a^^^2 + -9 * b^^^2)) ";
val e234b = the (rewrite_set thy' "rational_erls" false rls' e234b');  

print("\n\nexample 235:\n");
print("a)\n");
val e235a'="((10 * x + 3 * y) / (12 * x * y + -18 * y^^^2)) + ((-6 * x + -3 * y) / (12 * x * y + 18 * y^^^2)) + ((-4 * x) / (4 * x^^^2 + -9 * y^^^2))";
val e235a = the (rewrite_set thy' "rational_erls" false rls' e235a'); 
print("b)\n"); 
val e235b'="((8 * a + b) / (4 * a * b + -2 * b^^^2)) + ((-4 * a + -1 * b) / (4 * a * b + 2 * b^^^2)) + ((-2 * a) / (4 * a^^^2 + -1 * b^^^2)) ";
val e235b = the (rewrite_set thy' "rational_erls" false rls' e235b');  
 
print("\n\nexample 236:\n");
print("a)\n"); 
val e236a'="((8 * a + 5 * b) / (20 * a * b + -50 * b^^^2)) + ((-4 * a + -5 * b) / (20 * a * b + 50 * b^^^2)) + ((-2 * a) / (4 * a^^^2 + -25 * b^^^2))";
val e236a = the (rewrite_set thy' "rational_erls" false rls' e236a');  
print("b)\n");   
val e236b'="((24 * x + y) / (6 * x * y + -2 * y^^^2)) + ((-18 * x + -1 * y) / (6 * x * y + 2 * y^^^2)) + ((-15 * x) / (9 * x^^^2 + -1 * y^^^2)) ";
val e236b = the (rewrite_set thy' "rational_erls" false rls' e236b');  

print("\n\nexample heuberger:\n");
val eheu'="(x^^^4 + x * y + x^^^3 * y + y^^^2) / (x + 5 * x^^^2 + y + 5 * x * y + x^^^2 * y^^^3 + x * y^^^4)";
val eheu = the (rewrite_set thy' "rational_erls" false rls' eheu');

print("\n\nexample stiefel:\n");
val est1'="(7) / (-14) + (-2) / (4)";
val est1 = the (rewrite_set thy' "rational_erls" false rls' est1');
if est1 = ("(-1) / 1",[]) then ()
else error "new behaviour in rationals.sml: est1'";
-------------------------------------------------------------------------*)


(*
   val t = (Thm.term_of o the o (parse thy))
	    "(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2)";
   val SOME (t',_) = factor_expanded_ thy t;
   UnparseC.term t';
 
   "((-3) - x) * ((-3) + x) / (((-3) + x) * ((-3) + x))"
   "(3 + x) * (3 - x) / ((3 - x) * (3 - x))"
*)



(*WN.28.8.02: tests for the 'reverse-rewrite' functions:
  these are defined in Rationals.ML and stored in 
  the 'reverse-ruleset' cancel*)

(*the term for which reverse rewriting is demonstrated*)
  val t = (Thm.term_of o the o (parse thy))
	      "(9 - x ^^^ 2) / (9 + 6 * x + x ^^^ 2)";
  val Rrls {scr=Rfuns {init_state=ini,locate_rule=loc,
  		       next_rule=nex,normal_form=nor,...},...} = cancel;

(*normal_form produces the result in ONE step*)
  val SOME (t',_) = nor t;
  UnparseC.term t';

(*initialize the interpreter state used by the 'me'*)
  val (t,_,revsets,_) = ini t;

(*find the rule 'r' to apply to term 't'*)
  val SOME r = nex revsets t;
  (*val r = Thm ("sym_#mult_2_3", "6 = 2 * 3") : rule*)

(*check, if the rule 'r' applied by the user to 't' belongs to the ruleset;
  if the rule is OK, the term resulting from applying the rule is returned,too;
  there might be several rule applications inbetween,
  which are listed after the thead in reverse order*)
  val (r,(t,asm))::_ = loc revsets t r;
  UnparseC.term t;
  "(9 - x ^^^ 2) / (3 ^^^ 2 + 6 * x + x ^^^ 2)";

(*find the next rule to apply*)
  val SOME r = nex revsets t;
  (*val r = Thm ("sym_#power_3_2", "9 = 3 ^^^ 2") : rule*)

(*check the next rule*)
  val (r,(t,asm))::_ = loc revsets t r;
  UnparseC.term t;
  "(3 ^^^ 2 - x ^^^ 2) / (3 ^^^ 2 + 6 * x + x ^^^ 2)";

(*find and check the next rules, rewrite*)
  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  UnparseC.term t;
  "(3 ^^^ 2 - x ^^^ 2) / (3 ^^^ 2 + 2 * 3 * x + x ^^^ 2)";

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  UnparseC.term t;
  "(3 - x) * (3 + x) / (3 ^^^ 2 + 2 * 3 * x + x ^^^ 2)";

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  UnparseC.term t;
  "(3 - x) * (3 + x) / ((3 + x) * (3 + x))";

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  val ss = UnparseC.term t;
  if ss = "(3 - x) / (3 + x)" then ()
  else error "rational.sml: new behav. in rev-set cancel";
  UnparseC.terms asm; 



(*WN.11.9.02: the 'reverse-ruleset' cancel*)

  (*the term for which reverse rewriting is demonstrated*)
  val t = (Thm.term_of o the o (parse thy))
	      "(9 + (-1)*x^^^2) / (9 + ((-6)*x + x^^^2))";
  val Rrls {scr=Rfuns {init_state=ini,locate_rule=loc,
  		       next_rule=nex,normal_form=nor,...},...} = cancel;
  (*normal_form produces the result in ONE step*)
  val SOME (t',_) = nor t;
  UnparseC.term t';
  (*initialize the interpreter state used by the 'me'*)
  val (t,_,revsets,_) = ini t;
(*
 val [rs] = revsets;
 filter_out (ThmC.member ["sym_real_add_zero_left",
		      "sym_real_mult_0",
		      "sym_real_mult_1"]) rs;

 10.10.02: dieser Fall terminiert nicht (make_poly enth"alt zu viele rules)
  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  UnparseC.term t;

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  UnparseC.term t;

 ------ revset ----------------------------------------------------
/// [Thm ("sym_real_add_zero_left", "?z = 0 + ?z"),
///  Thm ("sym_real_mult_0", "0 = 0 * ?z"),
!    Thm ("sym_#mult_2_(-3)", "(-6) * x = 2 * ((-3) * x)"),
!    Thm ("sym_#add_(-3)_3", "0 = (-3) + 3"),
 
?    Thm ("sym_real_num_collect_assoc",
       "[| ?l is_const; ?m is_const |]
  	==> (?l + ?m) * ?n + ?k = ?l * ?n + (?m * ?n + ?k)"),
OK   Thm ("sym_real_mult_2_assoc", "2 * ?z1.0 + ?k = ?z1.0 + (?z1.0 + ?k)"),
OK   Thm ("sym_real_add_left_commute", "?y + (?x + ?z) = ?x + (?y + ?z)"),
///  Thm ("sym_real_mult_1", "?z = 1 * ?z"),
!    Thm ("sym_#power_3_2", "9 = 3 ^^^ 2"),
!    Thm ("sym_#mult_-1_-1", "1 * x ^^^ 2 = -1 * (-1 * x ^^^ 2)"),
!    Thm ("sym_#mult_-1_3", "(-3) * x = -1 * (3 * x)"),
OK   Thm ("realpow_twoI", "?r1 ^^^ 2 = ?r1 * ?r1"  [.]),
OK   Thm ("sym_real_add_assoc",
      "?z1.0 + (?z2.0 + ?z3.0) = ?z1.0 + ?z2.0 + ?z3.0"),
OK   Thm
     ("sym_mult.assoc", "?z1.0 * (?z2.0 * ?z3.0) = ?z1.0 * ?z2.0 * ?z3.0"),
OK   Thm ("sym_real_mult_left_commute",
      "?z2.0 * (?z1.0 * ?z3.0) = ?z1.0 * (?z2.0 * ?z3.0)"),
OK   Thm ("sym_mult_commute", "?w * ?z = ?z * ?w"),
?    Thm ("sym_real_add_mult_distrib2",
      "?w * ?z1.0 + ?w * ?z2.0 = ?w * (?z1.0 + ?z2.0)"),
?    Thm ("sym_real_add_mult_distrib",
      "?z1.0 * ?w + ?z2.0 * ?w = (?z1.0 + ?z2.0) * ?w"),
OK   Thm ("real_mult_div_cancel2", "?k ~= 0 ==> ?m * ?k / (?n * ?k) = ?m / ?n")]
 -------- revset ---------------------------------------------------- 

  val t = (Thm.term_of o the o (parse thy)) "(-6) * x";
  val t = (Thm.term_of o the o (parse thy)) 
	      "(9 + (-1)*x^^^2) / (9 + ((-6)*x + x^^^2))";
  val thm = (mk_thm thy "(-6) * x = 2 * ((-3) * x)") 
      handle e => OldGoals.print_exn e;
  val SOME (t',_) = rewrite_ thy e_rew_ord Rule_Set.empty false thm t;     
  UnparseC.term t';
----------------------------------------------------------------------*)



(* SK: Testbeispiele --- WN kopiert Rational.ML -> rational.sml-----

val t1 = (Thm.term_of o the o (parse thy)) "((3 * x^^^2 + 6 *x + 3) / (2*x + 2))";
val SOME (t1',rest)= cancel_ thy t1;
val SOME (t1'',_)= factor_out_gcd_ thy t1;
print(UnparseC.term t1'^" + Einschr\"ankung: "^UnparseC.term (hd(rest)));
UnparseC.term t1'';

val t1 = (Thm.term_of o the o (parse thy)) "((-3 * x^^^2 + 6 *x - 3) / (2*x - 2))";
val SOME (t1',_)= cancel_ thy t1;
val SOME (t1'',_)= factor_expanded_ thy t1;
UnparseC.term t1';
UnparseC.term t1'';

val t2 = (Thm.term_of o the o (parse thy)) "((x+ (-1)) / (x + 1)) + ((x + 1) / (x + (-1)))";
val SOME (t2',_) = add_fractions_ thy t2;
val SOME (t2'',_) = common_nominators_ thy t2; 
UnparseC.term t2';
UnparseC.term t2'';

val t2 = (Thm.term_of o the o (parse thy)) "((x - 1) / (x + 1)) + ((x + 1) / (x - 1))";
val SOME (t2',_) = add_expanded_frac_ thy t2;
val SOME (t2'',_) = common_expanded_nom_ thy t2; 
UnparseC.term t2';
UnparseC.term t2'';


val t3 = (Thm.term_of o the o (parse thy)) "((1) / (2*x + 2)) + ((1) / (2*x + (-2))) + ((1) / ( x^^^2 + (-1)))+((1) / (x^^^2 + (-2)*x + 1))";
val SOME (t3',_) = common_nominators_ thy t3; 
val SOME (t3'',_) = add_fractions_ thy t3; 
(UnparseC.term t3');
(UnparseC.term t3'');

val t3 = (Thm.term_of o the o (parse thy)) "((1) / (2*x + 2)) + ((1) / (2*x - 2)) + ((1) / ( x^^^2 - 1))+((1) / (x^^^2 - 2 * x + 1))";
val SOME (t3',_) = common_expanded_nom_ thy t3; 
val SOME (t3'',_) = add_expanded_frac_ thy t3; 
(UnparseC.term t3');
(UnparseC.term t3'');
-------------------------------*)

(*
val SOME(t4,t5) = norm_rational_ thy t3;
UnparseC.term t4;
UnparseC.term (hd(t5));*)

(*val test1 = (Thm.term_of o the o (parse thy)) "1 - x^^^2 - 5 * x^^^5";
val test2 = (Thm.term_of o the o (parse thy)) "1 + (-1) * x ^^^ 2 + (-5) * x ^^^ 5";
val test2 = (Thm.term_of o the o (parse thy)) "1 - x";
val test2 = (Thm.term_of o the o (parse thy)) "1 + (-1) * x";
UnparseC.term(expanded2term(test1));
UnparseC.term(term2expanded(test2)); *)



(* WN kopiert 16.10.02 Rational.ML -> rational.sml-----vvv---*)

  val t=(Thm.term_of o the o (parse thy)) "(9 - x^^^2)/(9 - 6*x + x^^^2)";
  val SOME (t',_) = factout_ thy t;
  val SOME (t'',_) = cancel_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "(3 + x) * (3 - x) / ((3 - x) * (3 - x))";
  "(3 + x) / (3 - x)";
  			   
  val t=(Thm.term_of o the o(parse thy))
	    "(9 - x^^^2) / (9 - 6*x + x^^^2) + 1 / (3 - x)";
  val SOME (t',_) = common_nominator_ thy t;
  val SOME (t'',_) = add_fraction_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "(9 - x ^^^ 2) / ((3 - x) * (3 - x)) + 1 * (3 - x) / ((3 - x) * (3 - x))";
  "(4 + x) / (3 - x)";

  (*WN.16.10.02 hinzugef"ugt -----vv---*)
  val t=(Thm.term_of o the o(parse thy))
	    "(9 - x^^^2) / (9 - 6*x + x^^^2) + 1";
  val SOME (t',_) = common_nominator_ thy t;
  val SOME (t'',_) = add_fraction_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2) +\
  \1 * (9 - 6 * x + x ^^^ 2) / (9 - 6 * x + x ^^^ 2)";
  "6 / (3 - x)";

  val t=(Thm.term_of o the o(parse thy))
	    "1 + (9 - x^^^2) / (9 - 6*x + x^^^2)";
  val SOME (t',_) = common_nominator_ thy t;
  val SOME (t'',_) = add_fraction_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "1 * (9 - 6 * x + x ^^^ 2) / (9 - 6 * x + x ^^^ 2) +\
  \(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2)";
  "6 / (3 - x)";
  (*WN.16.10.02 hinzugef"ugt -----^^---*)

  val t=(Thm.term_of o the o (parse thy)) 
  	    "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2)";
  val SOME (t',_) = factout_ thy t;
  val SOME (t'',_) = cancel_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "(y + x) * (y - x) / ((y - x) * (y - x))";
  "(y + x) / (y - x)";
    
  val t=(Thm.term_of o the o (parse thy)) 
	    "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2) + 1 / (y - x)";
  val SOME (t',_) = common_nominator_ thy t;
  val SOME (t'',_) = add_fraction_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "((-1) * x ^^^ 2 + y ^^^ 2) / (((-1) * x + y) * ((-1) * x + y)) +\
  \1 * ((-1) * x + y) / (((-1) * x + y) * ((-1) * x + y))";
  "((-1) - x - y) / (x - y)";
  (*WN.16.10.02     ^^^^^^^ Reihenfolge aus Angabe umgekehrt ?!*)

  val t=(Thm.term_of o the o (parse thy)) 
	    "(x^^^2 - y^^^2)/(x^^^2 - 2*x*y + y^^^2) + 1 / (x - y)";
  val SOME (t',_) = common_nominator_ thy t;
  val SOME (t'',_) = add_fraction_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "((-1) * y ^^^ 2 + x ^^^ 2) / (((-1) * y + x) * ((-1) * y + x)) +\
  \1 * ((-1) * y + x) / (((-1) * y + x) * ((-1) * y + x))";
  "((-1) - y - x) / (y - x)";
  (*WN.16.10.02     ^^^^^^^ lexicographische Ordnung ?!*)

  val t=(Thm.term_of o the o (parse thy)) 
  	    "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2)";
  val SOME (t',_) = norm_expanded_rat_ thy t;
  UnparseC.term t';
  "(y + x) / (y - x)";
(*val SOME (t'',_) = norm_rational_ thy t;
  UnparseC.term t'';
  *** RATIONALS_TERM2POLY_EXCEPTION: Invalid Polynomial 
  WN.16.10.02 ?!*)
 
  val t=(Thm.term_of o the o (parse thy)) 
	    "(9 - x^^^2)/(9 - 6*x + x^^^2) + (1)/(3 + x)";
  val SOME (t',_) = norm_expanded_rat_ thy t;
  UnparseC.term t';
  "(12 + 5 * x + x ^^^ 2) / (9 - x ^^^ 2)";
(*val SOME (t'',_) = norm_rational_ thy t;
  UnparseC.term t'';
  *** RATIONALS_TERM2POLY_EXCEPTION: Invalid Polynomial
  WN.16.10.02 ?!*)
 
  val t=(Thm.term_of o the o (parse thy)) 
	    "(9 + (-1)* x^^^2)/(9 + (-1)* 6*x + x^^^2) + (1)/(3 + x)";
  val SOME (t',_) = norm_expanded_rat_ thy t;
  val SOME (t'',_) = norm_rational_ thy t;
  UnparseC.term t';
  UnparseC.term t'';
  "(12 + 5 * x + x ^^^ 2) / (9 - x ^^^ 2)";
  "(12 + 5 * x + x ^^^ 2) / (9 + (-1) * x ^^^ 2)";
(* WN kopiert 16.10.02 Rational.ML -> rational.sml-----^^^---*)



