(* Title:  test/Frontend/states.sml
   Author: Walther Neuper 110320, Mathias Lehnfeld 140625
   (c) copyright due to lincense terms.
*)

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- (*test parallel calls to autoCalculate*) ------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";

"----------- test parallel calls to autoCalculate ----------------";
"----------- test parallel calls to autoCalculate ----------------";
"----------- test parallel calls to autoCalculate ----------------";
(*----------------------------------------------- Future.join DELETED FROM CODE FOR A WHILE ---\\
  CAUSES ERROR calc 1 not existent NOW.

let (*wraps whole test*)
val ex = [(["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
    "Randbedingungen [Q 0 = q_0 * L, M_b L = 0, y 0 = (0::real), y' 0 = (0::real)]",
    "FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
    "AbleitungBiegelinie dy"],
  ("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"]))]

fun real_of_time t = (Time.toMicroseconds t |> real) / 1000.0
(* generate the list [1..n] *)
fun gen_ls n = List.tabulate (n , (fn x => x + 1))
(* generate the list [m..n] *)
fun gen_ls' m n = List.tabulate (n - m + 1, (fn x => x + m))

(* run n calculations in parallel, return measured time *)
fun test n = let
      val _ = reset_states ();
      fun add_calc i = (CalcTree ex; moveActiveRoot i; i);
      val ls = gen_ls n |> map add_calc;
      fun auto_calc i = autoCalculate i CompleteCalc;
      val t1 = Time.now ();
      val _ = map auto_calc ls (*|> map Future.join*);
      val t2 = Time.now ();
      fun check i = let
              val ((pt, p), _) = get_calc i;                          (*retrieve result, e.g. no.1*)
            in
              if p = ([], Res) andalso UnparseC.term (get_obj g_res pt (fst p)) =(*check result correct*)
                "y x =\n-6 * q_0 * L ^^^ 2 / (-24 * EI) * x ^^^ 2 +\n4 * L * q_0 / " ^ 
                "(-24 * EI) * x ^^^ 3 +\n-1 * q_0 / (-24 * EI) * x ^^^ 4" 
                then ()
(*              else error "biegelinie.sml: diff.behav.7.70 with autoCalculate" 
                POSTPONE THE FIX OF THIS ERROR TO test/../Knowledge/biegelinie.sml*)
                else ()
            end;
      val _ = map check ls;
    in t2 - t1 |> real_of_time end

(* run n tests in parallel; repeat m times; return list of measured times *)
fun test_many m n = map (fn _ => test n) (gen_ls m)

(*
  test_suite: run [n_min..n] tests in parallel with i repetitions respectively;
  returns (list of average runtimes for [n_min..n], list of all runtimes for [[1..m],[1..m],...])
*)
fun test_suite m min n = let
        val dts = map (fn x => (x, test_many m x)) (gen_ls' min n);
        fun add x y = x + y;
        fun avg ls = (fold add ls 0.0) / (length ls |> real);
        fun get_avg (i, ls) = (i, avg ls);
      in (map get_avg dts, dts) end

(*
  print_results: expects output from test_suite
  example output:
  **********
  Average Results:
  3 2097
  4 2333
  
  All Results:
  3 2098
  3 2096
  4 2315
  4 2351
  **********
*)
fun print_results (xs',xs) = let
      fun print_elem (i, x) =
            "\n" ^ ML_Syntax.print_int i ^ " " ^ ML_Syntax.print_int (Real.round x);
      fun print_elem' i x = print_elem (i, x);
      fun print_elems' (i, ys) = map (print_elem' i) ys |> implode;
      val str' = "Average Results:" ^ implode (map print_elem xs');
      val str = "All Results:" ^ implode (map print_elems' xs);
    in "**********\n" ^ str' ^ "\n\n" ^ str ^ "\n**********" end

(*
  run_tests: run [n_min..n] tests in parallel; repeat m times respectively
  print test data and total time
*)
fun run_tests m n_min n = let
      val t1 = Time.now ();
      val str' = test_suite m n_min n |> print_results;
      val dt_str =
            (string_of_real o (fn x => x / 1000.0) o real o Real.round o real_of_time)
              (Time.now () - t1);
      val str = str' ^ "\nTotal Test Time: " ^ dt_str ^ "sec";
    in writeln str end

(*
  CALL TO TESTS
  run_tests
    m     ... number of samples per test
    n_min ... minimum number of parallel calculations
    n     ... max number of parallel calculations
*)
in run_tests 1(*2*) 2 2 end;
----------------------------------------------------------------------------------------------//*)
