(* Title:  "ProgLang/evaluate.sml"
           test calculation of values for function constants
   Author: Walther Neuper 2000
   (c) copyright due to lincense terms.
*)

"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"-calculate.thy: provides 'setup' -----------------------";
"----------- fun norm -----------------------------------";
"----------- check return value of adhoc_thm  ----";
"----------- fun calculate_ --------------------------------------------------------------------";
"----------- calculate from Prog --------------------------------- -----------------------------";
"----------- calculate from script --requires 'setup'----";
"----------- calculate check test-root-equ --------------";
"----------- check calcul,ate bottom up -----------------";
"----------- Prog_Expr.pow Power.power_class.power ---------";
" ================= evaluate.sml: calculate_ 2002 ======";
"----------- get_pair with 3 args -----------------------";
"----------- calculate (2 * x is_const) -----------------";
"----------- fun get_pair: examples ------------------------------------------------------------";
"----------- fun adhoc_thm: examples -----------------------------------------------------------";
"----------- fun power -------------------------------------------------------------------------";
"----------- fun divisors ----------------------------------------------------------------------";
"----------- fun doubles, fun squfact ----------------------------------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";

"----------- check return value of adhoc_thm  ----";
"----------- check return value of adhoc_thm  ----";
"----------- check return value of adhoc_thm  ----";
val thy = @{theory "Poly"};
val cal = snd (assoc_calc' thy "is_polyexp");
val t = @{term "(x / x) is_polyexp"};
val SOME (thmID, thm) = adhoc_thm thy cal t;
(HOLogic.dest_Trueprop (Thm.prop_of thm); writeln "all thms wrapped by Trueprop")
handle TERM _ => 
       error "evaluate.sml: adhoc_thm must return Trueprop";

"----------- fun calculate_ --------------------------------------------------------------------";
"----------- fun calculate_ --------------------------------------------------------------------";
"----------- fun calculate_ --------------------------------------------------------------------";
(* fun rewrite__set_ \<longrightarrow> fun rew_once works the same way *)
val t = str2term "((1+2)*4/3)^^^2";
val thy = @{theory};
val times =  ("Groups.times_class.times", eval_binop "#mult_") : string * Eval_Def.eval_fn;
val plus =   ("Groups.plus_class.plus",eval_binop "#add_") : string * Eval_Def.eval_fn;
val divide = ("Rings.divide_class.divide"  ,eval_cancel "#divide_e") : string * Eval_Def.eval_fn;
val pow =    ("Prog_Expr.pow"  ,eval_binop "#power_") : string * Eval_Def.eval_fn;

"~~~~~ fun calculate_, args:"; val (thy, isa_fn, t) = (thy, plus, t);
val SOME ("#: 1 + 2 = 3", adh_thm) = adhoc_thm @{theory} isa_fn t;
val SOME (t', []) = rewrite__ thy 0 [] e_rew_ord Rule_Set.empty true adh_thm t;
if UnparseC.term t' = "(3 * 4 / 3) ^^^ 2" then () else error "calculate_  1 + 2 = 3  changed";

"~~~~~ fun calculate_, args:"; val (thy, isa_fn, t) = (thy, times, t');
val SOME ("#: 3 * 4 = 12", adh_thm) = adhoc_thm @{theory} isa_fn t';
val SOME (t'', []) = rewrite__ thy 0 [] e_rew_ord Rule_Set.empty true adh_thm t;
if UnparseC.term t'' = "(12 / 3) ^^^ 2" then () else error "calculate_  3 * 4 = 12  changed";

"~~~~~ fun calculate_, args:"; val (thy, isa_fn, t) = (thy, divide, t'');
val SOME ("#divide_e12_3", adh_thm) = adhoc_thm @{theory} isa_fn t;
val SOME (t''', []) = rewrite__ thy 0 [] e_rew_ord Rule_Set.empty true adh_thm t;
if UnparseC.term t''' = "4 ^^^ 2" then () else error "calculate_  12 / 3 = 4  changed";

"~~~~~ fun calculate_, args:"; val (thy, isa_fn, t) = (thy, pow, t''');
val SOME ("#: 4 ^^^ 2 = 16", adh_thm) = adhoc_thm @{theory} isa_fn t;
val SOME (t'''', []) = rewrite__ thy 0 [] e_rew_ord Rule_Set.empty true adh_thm t;
if UnparseC.term t'''' = "16" then () else error "calculate_  12 / 3 = 4  changed";

"----------- calculate from Prog --------------------------------- -----------------------------";
"----------- calculate from Prog --------------------------------- -----------------------------";
"----------- calculate from Prog --------------------------------- -----------------------------";
val thy = @{theory "Test"};
val fmz = ["realTestGiven (((1+2)*4/3)^^^2)", "realTestFind s"];
val (dI',pI',mI') =
  ("Test",["calculate", "test"],["Test", "test_calculate"]);

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt =("Add_Given",Add_Given "realTestGiven (((#1 + #2) * #4 // #3) ^^^#2)")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Add_Find",Add_Find "realTestFind s") : string * tac*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Specify_Theory",Specify_Theory "Test") : string * tac*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Specify_Problem",Specify_Problem ["calculate", "test"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Specify_Method",Specify_Method ("Test", "test_calculate"))*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Apply_Method",Apply_Method ("Test", "test_calculate"))*)

(*[1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p [1] pt; (*nxt = ("Calculate",Calculate "PLUS")*)
(*[1], Res*)val (p,_,f,nxt,_,pt) = me nxt p [1] pt; (*nxt = ("Calculate",Calculate "TIMES")*)
(*[2], Res*)val (p,_,f,nxt,_,pt) = me nxt p [1] pt; (*nxt = ("Calculate",Calculate "DIVIDE")*)
(*[3], Res*)val (p,_,f,nxt,_,pt) = me nxt p [1] pt; (*nxt = ("Calculate",Calculate "POWER")*)
(*[4], Res*)val (p,_,f,nxt,_,pt) = me nxt p [1] pt; (*nxt = ("Check_Postcond",Check_Postcond ["calculate", "test"])*)
(*[], Res*)val (p,_,f,nxt,_,pt) = me nxt p [1] pt; (*nxt = ("End_Proof'",End_Proof')*)
case f of Test_Out.FormKF "16" => () | _ =>
error "evaluate.sml: script test_calculate changed behaviour";


"----------- calculate check test-root-equ --------------";
"----------- calculate check test-root-equ --------------";
"----------- calculate check test-root-equ --------------";
(*(1): 2nd Test_simplify didn't work:
val ct =
  "sqrt (x ^^^ 2 + -3 * x) = (-3 + 2 * x + -1 * (9 + 4 * x)) / (-1 * 2)"
> val rls = ("Test_simplify");
> val (ct,_) = the (rewrite_set thy' ("tval_rls") false rls ct);
val ct = "sqrt (x ^^^ 2 + -3 * x) =
(-9) / (-2) + (-3 / (-2) + (x * ((-4) / (-2)) + x * (2 / (-2))))";
ie. cancel does not work properly
*)
 val thy = @{theory "Test"};
 val op_ = the (LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "DIVIDE"));
 val ct = ThmC_Def.num_to_Free @{term
   "sqrt (x ^^^ 2 + -3 * x) = (-9) / (-2) + (-3 / (-2) + (x * ((-4) / (-2)) + x * (2 / (-2))))"};
case calculate_ thy op_ ct of
  SOME _ => ()
| NONE => error "calculate_ test-root-equ changed";
(*
           sqrt (x ^^^ 2 + -3 * x) =\
 \(-9) / (-2) + (-3 / (-2) + (x * ((-4) / (-2)) + x * (2 / (-2))))
............... does not work *)

(*--------------(2): does divide work in Test_simplify ?: ------*)
 val thy = @{theory Test};
 val t = (Thm.term_of o the o (parse thy)) "6 / 2";
 val rls = Test_simplify;
 val (t,_) = the (rewrite_set_ thy false rls t);
(*val t = Free ("3", "Real.real") : term*)

(*--------------(3): is_const works ?: -------------------------------------*)
 val t = (Thm.term_of o the o (parse @{theory Test})) "2 is_const";
 atomty t;
 rewrite_set_ @{theory Test} false tval_rls t;
(*val it = SOME (Const ("HOL.True", "bool"),[]) ... works*)

 val t = str2term "2 * x is_const";
 val SOME (str,t') = eval_const "" "" t (@{theory "Isac_Knowledge"});
 UnparseC.term t';
 

"----------- check calculate bottom up ------------------";
"----------- check calculate bottom up ------------------";
"----------- check calculate bottom up ------------------";
(*-------------- eval_cancel works: *)
 Rewrite.trace_on := false;
 val thy = @{theory Test};
 val rls = Test_simplify;
 val t = (Thm.term_of o the o (parse thy)) "(-4) / 2";

val SOME (_, t) = eval_cancel "xxx" "Rings.divide_class.divide" t thy;

(*--------------(5): reproduce (1) with simpler term: ------------*)
 val t = (Thm.term_of o the o (parse thy)) "(3+5)/2";
case rewrite_set_ thy false rls t of
  SOME (Free ("4", _), []) => ()
| _ => error "rewrite_set_ (3+5)/2 changed";

 val t = (Thm.term_of o the o (parse thy)) "(3+1+2*x)/2";
case rewrite_set_ thy false rls t of
  SOME (Const ("Groups.plus_class.plus", _) $ Free ("2", _) $ Free ("x", _), []) => ()
| _ => error "rewrite_set_ (3+1+2*x)/2 changed";

 Rewrite.trace_on:=false; (*=true3.6.03*)

(*--- Rewrite.trace_on before correction of ... --------------------
 val ct = "(-3 + 2 * x + -1) / 2";
 val (ct,_) = the (rewrite_set thy'  false rls ct);
:
### trying thm 'root_ge0_2'
### rewrite_set_: x + (-1 + -3) / 2
### trying thm 'radd_real_const_eq'
### trying thm 'radd_real_const'
### rewrite_set_: x + (-4) / 2
### trying thm 'rcollect_right'
:
"x + (-4) / 2"
-------------------------------------while before Isabelle20002:
 val ct = "(#-3 + #2 * x + #-1) // #2";
 val (ct,_) = the (rewrite_set thy'  false rls ct);
:
### trying thm 'root_ge0_2'
### rewrite_set_: x + (#-1 + #-3) // #2
### trying thm 'radd_real_const_eq'
### trying thm 'radd_real_const'
### rewrite_set_: x + #-4 // #2
### rewrite_set_: x + #-2
### trying thm 'rcollect_right'
:
"#-2 + x"
-----------------------------------------------------------------*)


(*===================*)
 Rewrite.trace_on:=false; (*WN130722: =true stopped Test_Isac.thy*)
 val t = (Thm.term_of o the o (parse thy))  "x + (-1 + -3) / 2";
val SOME (res, []) = rewrite_set_ thy false rls t;
if UnparseC.term res = "-2 + x" then () else error "rewrite_set_  x + (-1 + -3) / 2  changed";
"x + (-4) / 2";						
(*
### trying calc. 'cancel'
@@@ get_pair: binop, t = x + (-4) / 2
@@@ get_pair: t else
@@@ get_pair: t else -> NONE
@@@ get_pair: binop, t = (-4) / 2
@@@ get_pair: then 1
@@@ get_pair: t -> NONE
@@@ get_pair: t1 -> NONE
@@@ adhoc_thm': NONE
### trying calc. 'pow'
*)

 Rewrite.trace_on:=false; (*WN130722: =true stopped Test_Isac.thy*)

"----------- Prog_Expr.pow Power.power_class.power ---------";
"----------- Prog_Expr.pow Power.power_class.power ---------";
"----------- Prog_Expr.pow Power.power_class.power ---------";
val t = (Thm.term_of o the o (parseold thy)) "1 ^ aaa";
atomty t;
(*** -------------
*** Const ( Nat.power, ['a, nat] => 'a)
*** . Free ( 1, 'a)
*** . Free ( aaa, nat) *)

val t = str2term "1 ^^^ aaa";
atomty t;
(**** 
*** Const (Prog_Expr.pow, real => real => real)
*** . Free (1, real)
*** . Free (aaa, real)
*** *);

" ================= evaluate.sml: calculate_ 2002 =================== ";
" ================= evaluate.sml: calculate_ 2002 =================== ";
" ================= evaluate.sml: calculate_ 2002 =================== ";

val thy = @{theory Test};
val t = (Thm.term_of o the o (parse thy)) "12 / 3";
val SOME (thmID,thm) = adhoc_thm thy(the(LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"DIVIDE")))t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
"12 / 3 = 4";
val thy = @{theory Test};
val t = (Thm.term_of o the o (parse thy)) "4 ^^^ 2";
val SOME (thmID,thm) = adhoc_thm thy(the(LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"POWER"))) t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
"4 ^ 2 = 16";

 val t = (Thm.term_of o the o (parse thy)) "((1 + 2) * 4 / 3) ^^^ 2";
 val SOME (thmID,thm) = adhoc_thm thy (the(LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"PLUS"))) t;
"1 + 2 = 3";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 UnparseC.term t;
"(3 * 4 / 3) ^^^ 2";
 val SOME (thmID,thm) = adhoc_thm thy (the(LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"TIMES")))t;
"3 * 4 = 12";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 UnparseC.term t;
"(12 / 3) ^^^ 2";
 val SOME (thmID,thm) =adhoc_thm thy(the(LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"DIVIDE")))t;
"12 / 3 = 4";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 UnparseC.term t;
"4 ^^^ 2";
 val SOME (thmID,thm) = adhoc_thm thy(the(LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"POWER")))t;
"4 ^^^ 2 = 16";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 UnparseC.term t;
"16";
 if it <> "16" then error "evaluate.sml: new behaviour in calculate_"
 else ();

(*13.9.02 *** calc: operator = pow not defined*)
  val t = (Thm.term_of o the o (parse thy)) "3^^^2";
  val SOME (thmID,thm) = 
      adhoc_thm thy (the(LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"POWER"))) t;
(*** calc: operator = pow not defined*)

  val (op_, eval_fn) = the (LibraryC.assoc(KEStore_Elems.get_calcs @{theory},"POWER"));
  (*
val op_ = "Prog_Expr.pow" : string
val eval_fn = fn : string -> term -> theory -> (string * term) option*)

  val SOME (thmid,t') = get_pair thy op_ eval_fn t;
(*** calc: operator = pow not defined*)

  val SOME (id,t') = eval_fn op_ t thy;
(*** calc: operator = pow not defined*)

  val (thmid, (Const (op0,t0) $ Free (n1,t1) $ Free(n2,t2))) = (op_, t);
  val SOME (id,t') = eval_binop thmid op_ t thy;
(*** calc: operator = pow not defined*)


"----------- get_pair with 3 args --------------------------------";
"----------- get_pair with 3 args --------------------------------";
"----------- get_pair with 3 args --------------------------------";
val (thy, op_, ef, arg) =
    (thy, "EqSystem.occur'_exactly'_in", 
     assoc_calc' (@{theory "EqSystem"}) "occur_exactly_in" |> snd |> snd,
     str2term
      "[] from [c, c_2, c_3, c_4] occur_exactly_in -1 * (q_0 * L ^^^ 2) / 2"
      );
val SOME (str, simpl) = get_pair thy op_ ef arg;
if str = 
"[] from [c, c_2, c_3, c_4] occur_exactly_in -1 * (q_0 * L ^^^ 2) / 2 = True"
then () else error "evaluate.sml get_pair with 3 args:occur_exactly_in";


"----------- calculate (2 * x is_const) -----------------";
"----------- calculate (2 * x is_const) -----------------";
"----------- calculate (2 * x is_const) -----------------";
val t = str2term "2 * x is_const";
val SOME (str, t') = eval_const "" "" t @{theory Test};
UnparseC.term t';
"(2 * x is_const) = False";

val SOME (t',_) = rewrite_set_ @{theory Test} false tval_rls t;
UnparseC.term t';
"HOL.False";

"----------- fun get_pair: examples ------------------------------------------------------------";
"----------- fun get_pair: examples ------------------------------------------------------------";
"----------- fun get_pair: examples ------------------------------------------------------------";
val thy = @{theory};
val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "PLUS");

val t = (Thm.term_of o the o (parse thy)) "3 + 4";
val SOME (str, term) = get_pair thy isa_str eval_fn t;
if str =  "#: 3 + 4 = 7" andalso UnparseC.term term = "3 + 4 = 7"
then () else error "get_pair  3 + 4  changed";

val t = (Thm.term_of o the o (parse thy)) "(a + 3) + 4";
val SOME (str, term) = get_pair thy isa_str eval_fn t;
if str =  "#: a + 3 + 4 = a + 7" andalso UnparseC.term term = "a + 3 + 4 = a + 7"
then () else error "get_pair  (a + 3) + 4  changed";

val t = (Thm.term_of o the o (parse thy)) "(a + 3) + 4";
val SOME (str, term) = get_pair thy isa_str eval_fn t;
if str =  "#: a + 3 + 4 = a + 7" andalso UnparseC.term term = "a + 3 + 4 = a + 7"
then () else error "get_pair  (a + 3) + 4  changed";

val t = (Thm.term_of o the o (parse thy)) "x = 5 * (3 + (4 + a))";
val SOME (str, term) = get_pair thy isa_str eval_fn t;
if str =  "#: 3 + (4 + a) = 7 + a" andalso UnparseC.term term = "3 + (4 + a) = 7 + a"
then ((* !!! gets subterm !!!*)) else error "get_pair  x = 5 * (3 + (4 + a))  (subterm) changed";

val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "DIVIDE");

val t = (Thm.term_of o the o (parse thy)) "-4 / -2";
val SOME (str, term) = get_pair thy isa_str eval_fn t;
if str =  "#divide_e-4_-2" andalso UnparseC.term term = "-4 / -2 = 2"
then () else error "get_pair  -4 / -2   changed";

val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "POWER");

val t = (Thm.term_of o the o (parse thy)) "2 ^^^ 3";
val SOME (str, term) = get_pair thy isa_str eval_fn t;
if str =  "#: 2 ^^^ 3 = 8" andalso UnparseC.term term = "2 ^^^ 3 = 8"
then () else error "get_pair  2 ^^^ 3   changed";

"----------- fun adhoc_thm: examples -----------------------------------------------------------";
"----------- fun adhoc_thm: examples -----------------------------------------------------------";
"----------- fun adhoc_thm: examples -----------------------------------------------------------";
(*--------------------------------------------------------------------vvvvvvvvvv*)
val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "is_const");
val SOME t = parseNEW @{context} "9 is_const";
val SOME (str, thm) = adhoc_thm thy (isa_str, eval_fn) t;
if str = "#is_const_9_" andalso ThmC_Def.string_of_thm thm = "(9 is_const) = True"
then () else error "adhoc_thm  9 is_const  changed";


case assoc_calc thy "Orderings.ord_class.less" of
  "le" => () | _ => error "Orderings.ord_class.less <-> le changed";
(*--------------------------------------------------------------------vvvvvvvvvv*)
val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "le");

val SOME t = parseNEW @{context} "4 < 4";
val SOME (str, thm) = adhoc_thm thy (isa_str, eval_fn) t;
if str = "#less_4_4" andalso ThmC_Def.string_of_thm thm = "(4 < 4) = False"
then () else error "adhoc_thm  4 < 4  changed";

val SOME t = parseNEW @{context} "a < 4";
case adhoc_thm thy (isa_str, eval_fn) t of
NONE => () | _ => error "adhoc_thm  a < 4  does NOT result in NONE";


(*--------------------------------------------------------------------vvvvvvvvvv*)
val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "PLUS");
val SOME t = parseNEW @{context} "1 + 2";
val SOME (str, thm) = adhoc_thm thy (isa_str, eval_fn) t;
if str = "#: 1 + 2 = 3" andalso ThmC_Def.string_of_thm thm = "1 + 2 = 3"
then () else error "adhoc_thm  1 + 2  changed";

(*--------------------------------------------------------------------vvvvvvvvvv*)
val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "DIVIDE");
val SOME t = parseNEW @{context} "6 / -8";
val SOME (str, thm) = adhoc_thm thy (isa_str, eval_fn) t;
if str = "#divide_e6_-8" andalso ThmC_Def.string_of_thm thm = "6 / -8 = -3 / 4"
then () else error "adhoc_thm  1 + 2  changed";


case assoc_calc thy "Prog_Expr.ident" of
  "ident" => () | _ => error "Prog_Expr.ident <-> ident  changed";
(*--------------------------------------------------------------------vvvvvvvvvv*)
val SOME (isa_str, eval_fn) = LibraryC.assoc (KEStore_Elems.get_calcs @{theory}, "ident");

val SOME t = parseNEW @{context} "3 =!= 3";
val SOME (str, thm) = adhoc_thm thy (isa_str, eval_fn) t;
if str = "#ident_(3)_(3)" andalso ThmC_Def.string_of_thm thm = "(3 =!= 3) = True"
then () else error "adhoc_thm  (3 =!= 3)  changed";

val SOME t = parseNEW @{context} "\<not> (4 + (4 * x + x ^ 2) =!= 0)";
val SOME (str, thm) = adhoc_thm thy (isa_str, eval_fn) t;
if str = "#ident_(4 + (4 * x + x ^ 2))_(0)" andalso ThmC_Def.string_of_thm thm = "(4 + (4 * x + x ^ 2) =!= 0) = False"
then () else error "adhoc_thm  (\<not> (4 + (4 * x + x ^ 2) =!= 0))  changed";

"----------- fun power -------------------------------------------------------------------------";
"----------- fun power -------------------------------------------------------------------------";
"----------- fun power -------------------------------------------------------------------------";
if power 2 3 = 8 then () else error "power 2 3 = 8";
if power ~2 3 = ~8 then () else error "power ~2 3 = ~8";
if power ~3 2 = 9 then () else error "power ~3 2 = 9";
(power 3 ~2; error "power 3 ~2: should raise an exn") handle _ => 000;

"----------- fun divisors ----------------------------------------------------------------------";
"----------- fun divisors ----------------------------------------------------------------------";
"----------- fun divisors ----------------------------------------------------------------------";
if divisors 30 = [5, 3, 2] then () else error "divisors 30 = [5, 3, 2]";
if divisors 32 = [2, 2, 2, 2, 2] then () else error "divisors 32 = [2, 2, 2, 2, 2]";
if divisors 60 = [5, 3, 2, 2] then () else error "divisors 60 = [5, 3, 2, 2]";
if divisors 11 = [11] then () else error "divisors 11 = [11]";

"----------- fun doubles, fun squfact ----------------------------------------------------------";
"----------- fun doubles, fun squfact ----------------------------------------------------------";
"----------- fun doubles, fun squfact ----------------------------------------------------------";
if doubles [2,3,4] = [] then () else error "doubles [2,3,4] changed";
if doubles [2,3,3,5,5,7] = [5, 3] then () else error "doubles [2,3,3,5,5,7] changed";

if squfact 30 = 1 then () else error "squfact  30  changed";
if squfact 32 = 4 then () else error "squfact  32  changed";
if squfact 60 = 2 then () else error "squfact  60  changed";
if squfact 11 = 1 then () else error "squfact  11  changed";
