(* Title:  "Specify/o-model.sml"
   Author: Walther Neuper
   (c) due to copyright terms
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- initialise O_Model.T --------------------------------------------------------------";
"----------- fun mark --------------------------------------------------------------------------";
"----------- fun coll_variants -----------------------------------------------------------------";
"----------- fun add_id ------------------------------------------------------------------------";
"----------- fun filter_vat --------------------------------------------------------------------";
"----------- regression test fun O_Model.is_copy_named -----------------------------------------";
"----------- .. CONTINUED regr.test fun O_Model.cpy_nam ----------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

open O_Model;
"----------- fun init for O_Model.T ------------------------------------------------------------";
"----------- fun init for O_Model.T ------------------------------------------------------------";
"----------- fun init for O_Model.T ------------------------------------------------------------";
val f_model = ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	"Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
	"FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
  "AbleitungBiegelinie dy"];
val f_spec = ("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"]);
(*[], Pbl*)val (p,_,f,nxt,_,pt) = CalcTreeTEST [(f_model, f_spec)]; (*\<rightarrow>Model_Problem*)

"~~~~~ fun CalcTreeTEST , args:"; val [(fmz, sp)] = [(f_model, f_spec)];

(*  val ((pt, p), tacis) =*)
Step_Specify.nxt_specify_init_calc (fmz, sp);
"~~~~~ fun nxt_specify_init_calc , args:"; val (fmz, (dI, pI, mI)) = (fmz, sp);
	    val thy = ThyC.get_theory dI;
	      (*if*) mI = ["no_met"] (*else*);
      val (pI, pors, mI) = (pI, Problem.from_store pI |> #ppc |> init fmz thy, mI);

(*+*)Problem.from_store pI: Problem.T;
(*+*)(Problem.from_store pI |> #ppc): Model_Pattern.T;

(*+*)val o_model = (Problem.from_store pI |> #ppc |>
   O_Model.init fmz thy);
"~~~~~ fun init , args:"; val (fmz, thy, pbt) = (fmz, thy, Problem.from_store pI |> #ppc);
      val ori = (map (fn str => str
                     |> TermC.parseNEW'' thy
                     |> Input_Descript.split
                     |> add_field thy pbt) fmz)
                 |> add_variants;

(*+  decompose..*)
(*+*)val aaa as Const ("Biegelinie.Traegerlaenge", _) $ Free ("L", _) = (nth 1 fmz) |> TermC.parseNEW'' thy;
(*+*)val bbb as (Const ("Biegelinie.Traegerlaenge", _), [Free ("L", _)]) = aaa |> Input_Descript.split;
(*+*)val ccc as ("#Given", Const ("Biegelinie.Traegerlaenge", _), [Free ("L", _)]) =  bbb |> add_field thy pbt;
(*+  WHY IS THE LIST IN "#Relate" NOT DECOMPOSED?...*)
(*+*)val ddd as [("#Given", Const ("Biegelinie.Traegerlaenge", _), [Free ("L", _)]),
                 ("#Given", Const ("Biegelinie.Streckenlast", _), [Free ("q_0", _)]),
                 ("#Find", Const ("Biegelinie.Biegelinie", _), [Free ("y", _)]),
                 ("#Relate", Const ("Biegelinie.Randbedingungen", _),
                   [Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ (Free ("y", _) $ Free ("0", _)) $ Free ("0", _)) $
                      Const ("List.list.Nil", _),
                    Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ (Free ("y", _) $ Free ("L", _)) $ Free ("0", _)) $
                      Const ("List.list.Nil", _),
                    Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ (Const ("Biegelinie.M'_b", _) $ Free ("0", _)) $ Free ("0", _)) $
                      Const ("List.list.Nil", _),
                    Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ (Const ("Biegelinie.M'_b", _) $ Free ("L", _)) $ Free ("0", _)) $
                      Const ("List.list.Nil", _)]),
                 ("#undef", Const ("Biegelinie.FunktionsVariable", _), [Free ("x", _)]),
                  _, _] =
               (map (fn str => str
                     |> TermC.parseNEW'' thy
                     |> Input_Descript.split
                     |> add_field thy pbt) fmz);
(*+*)val eee as [(0, ("#Given", Const ("Biegelinie.Traegerlaenge", _), [Free ("L", _)])),
                 _, _, _, _, _, _] = add_variants ddd;

      val maxv = map fst ori |> max;
      val maxv = if maxv = 0 then 1 else maxv;
      val oris = ori
        |> coll_variants
        |> map (replace_0 maxv |> apfst)
        |> add_id
        |> map flattup;

(*+  decompose..*)
(*+*)val fff as [([0], ("#Given", _, _)), _, _, _, _, _, _]  = ori |> coll_variants;
(*+*)val ggg as [([1], ("#Given", _, _)), _, _, _, _, _, _] = fff |> map (replace_0 maxv |> apfst);
(*+*)val hhh as [(1, ([1], ("#Given", _, _))), (2, ([1], ("#Given", _, _))), _, _, _, _, _] = ggg |> add_id;
(*+*)val iii = hhh |> map flattup;
(*+*)val iii as [(1, [1], "#Given", _, _), (2, [1], "#Given", _, _), _, _, _, _, _] = hhh |> map flattup;

      (oris, ctxt)  (*return from O_Model.init*);
"~~~~~ from fun O_Model.init \<longrightarrow>fun nxt_specify_init_calc , return:"; val (pors, pctxt) = (oris, ctxt);

(* final test ...*)
(*+*)if O_Model.to_string pors = "[\n" ^ 
  "(1, [\"1\"], #Given, Traegerlaenge, [\"L\"]), \n" ^ 
  "(2, [\"1\"], #Given, Streckenlast, [\"q_0\"]), \n" ^ 
  "(3, [\"1\"], #Find, Biegelinie, [\"y\"]), \n" ^ 
  "(4, [\"1\"], #Relate, Randbedingungen, [\"[y 0 = 0]\", \"[y L = 0]\", \"[M_b 0 = 0]\", \"[M_b L = 0]\"]), \n" ^ 
  "(5, [\"1\"], #undef, FunktionsVariable, [\"x\"]), \n" ^ 
  "(6, [\"1\"], #undef, GleichungsVariablen, [\"[c]\", \"[c_2]\", \"[c_3]\", \"[c_4]\"]), \n" ^ 
  "(7, [\"1\"], #undef, AbleitungBiegelinie, [\"dy\"])]"
then () else error "O_Model.init CHANGED";


"----------- ..CONTIUNED: initialise ctxt ------------------------------------------------------";
"----------- ..CONTIUNED: initialise ctxt ------------------------------------------------------";
"----------- ..CONTIUNED: initialise ctxt ------------------------------------------------------";
    val ctxt = ContextC.initialise' thy f_model;
case parseNEW ctxt "L" of
  SOME (Free ("L", Type ("Real.real", []))) => ()
| _ => error "ContextC.initialise' CHANGED";

"----------- fun mark --------------------------------------------------------------------------";
"----------- fun mark --------------------------------------------------------------------------";
"----------- fun mark --------------------------------------------------------------------------";
val xs = [1,1,1,2,4,4,5];
val xxx = mark (op=) xs;
if xxx = [(1,1),(2,1),(3,1),(0,2),(1,4),(2,4),(0,5)]
then () else error "fun mark CHANGED";

"----------- fun coll_variants -----------------------------------------------------------------";
"----------- fun coll_variants -----------------------------------------------------------------";
"----------- fun coll_variants -----------------------------------------------------------------";
val xs = [(1,1),(2,1),(3,1),(0,2),(1,4),(2,4),(0,5)];

if coll_variants xs = [([1, 2, 3], 1), ([0], 2), ([1, 2], 4), ([0], 5)]
then () else error "fun coll_variants CHANGED";

"----------- fun add_id ------------------------------------------------------------------------";
"----------- fun add_id ------------------------------------------------------------------------";
"----------- fun add_id ------------------------------------------------------------------------";
val xs = [([1,2,3],1),([0],2),([1,2],4),([0],5)];
val xxx = add_id xs;

if add_id xs = [(1, ([1, 2, 3], 1)), (2, ([0], 2)), (3, ([1, 2], 4)), (4, ([0], 5))]
then () else error "fun add_id CHANGED";


"----------- fun filter_vat --------------------------------------------------------------------";
"----------- fun filter_vat --------------------------------------------------------------------";
"----------- fun filter_vat --------------------------------------------------------------------";
val formalise = [
  "fixedValues [r=Arbfix]", "maximum A", "valuesFor [a,b]",
	"relations [A=a*b, (a/2)^2 + (b/2)^2 = r^2]",
	"relations [A=a*b, (a/2)^2 + (b/2)^2 = r^2]",
  "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos (alpha::real)]",
	(*^^^ these are the elements for the root-problem (in variants)*)
        (*vvv these are elements required for subproblems*)
	"boundVariable a", "boundVariable b", "boundVariable alpha",
	"interval {x::real. 0 <= x & x <= 2*r}",
	"interval {x::real. 0 <= x & x <= 2*r}",
	"interval {x::real. 0 <= x & x <= pi}",
	"errorBound (eps=(0::real))"]
val pbt as {ppc = ppc,...} =
    Problem.from_store ["maximum_of", "function"];
val o_model = O_Model.init formalise @{theory} ppc;

case o_model of
[
  (1, [1, 2, 3], "#Given", Const ("Input_Descript.fixedValues", _), [Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ Free ("r", _) $ Const ("Program.Arbfix", _)) $ _]),
  (2, [1, 2, 3], "#Find", Const ("Input_Descript.maximum", _), [Free ("A", _)]), 
  (3, [1, 2, 3], "#Find", Const ("Input_Descript.valuesFor", _), [_ $ Free ("a", _) $ _, Const ("List.list.Cons", _) $ Free ("b", _) $ _]),
  (4, [1, 2], "#Relate",  Const ("Input_Descript.relations", _), _),
  (5, [3], "#Relate", Const ("Input_Descript.relations", _), _),
  (6, [1], "#undef", Const ("Input_Descript.boundVariable", _), [Free ("a", _)]),
  (7, [2], "#undef", Const ("Input_Descript.boundVariable", _), [Free ("b", _)]),
  (8, [3], "#undef", Const ("Input_Descript.boundVariable", _), [Free ("alpha", _)]),
  (9, [1, 2], "#undef", Const ("Input_Descript.interval", _), [Const ("Set.Collect", _) $ Abs ("x", _, Const ("HOL.conj", _) $ _ $ _)]),
  (10, [3], "#undef", Const ("Input_Descript.interval", _), _),
  (11, [1, 2, 3], "#undef", Const ("Input_Descript.errorBound", _), [Const ("HOL.eq", _) $ Free ("eps", _) $ Free ("0", _)])
] => ()
| _ =>  error "fun O_Model.init CHANGED";

(*/------- unused code -----------------------------------------------------------------------\*)
fun filter_vat oris i = filter ((member_swap op = i) o (#2 : O_Model.single -> int list)) oris;
filter_vat : O_Model.T -> int -> O_Model.T;
(*\------- unused code -----------------------------------------------------------------------/*)

val filtered = map (filter_vat o_model) [1,2,3];
(*DIFFERENT ARGUMENT HERE         ^^^^^^^  DOES not CHANGE ANYTHING .. ?error?*)

case filtered of
  [[
    (1, [1, 2, 3], "#Given", Const ("Input_Descript.fixedValues", _), [Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ Free ("r", _) $ Const ("Program.Arbfix", _)) $ _]),
    (2, [1, 2, 3], "#Find", Const ("Input_Descript.maximum", _), [Free ("A", _)]), 
    (3, [1, 2, 3], "#Find", Const ("Input_Descript.valuesFor", _), [_ $ Free ("a", _) $ _, Const ("List.list.Cons", _) $ Free ("b", _) $ _]),
    (4, [1, 2], "#Relate",  Const ("Input_Descript.relations", _), _),
    (6, [1], "#undef", Const ("Input_Descript.boundVariable", _), [Free ("a", _)]),
    (9, [1, 2], "#undef", Const ("Input_Descript.interval", _), [Const ("Set.Collect", _) $ Abs ("x", _, Const ("HOL.conj", _) $ _ $ _)]),
    (11, [1, 2, 3], "#undef", Const ("Input_Descript.errorBound", _), [Const ("HOL.eq", _) $ Free ("eps", _) $ Free ("0", _)])
  ], [
    (1, [1, 2, 3], "#Given", Const ("Input_Descript.fixedValues", _), [Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ Free ("r", _) $ Const ("Program.Arbfix", _)) $ _]),
    (2, [1, 2, 3], "#Find", Const ("Input_Descript.maximum", _), [Free ("A", _)]), 
    (3, [1, 2, 3], "#Find", Const ("Input_Descript.valuesFor", _), [_ $ Free ("a", _) $ _, Const ("List.list.Cons", _) $ Free ("b", _) $ _]),
    (4, [1, 2], "#Relate",  Const ("Input_Descript.relations", _), _),
    (7, [2], "#undef", Const ("Input_Descript.boundVariable", _), [Free ("b", _)]),
    (9, [1, 2], "#undef", Const ("Input_Descript.interval", _), [Const ("Set.Collect", _) $ Abs ("x", _, Const ("HOL.conj", _) $ _ $ _)]),
    (11, [1, 2, 3], "#undef", Const ("Input_Descript.errorBound", _), [Const ("HOL.eq", _) $ Free ("eps", _) $ Free ("0", _)])
  ], [
    (1, [1, 2, 3], "#Given", Const ("Input_Descript.fixedValues", _), [Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ Free ("r", _) $ Const ("Program.Arbfix", _)) $ _]),
    (2, [1, 2, 3], "#Find", Const ("Input_Descript.maximum", _), [Free ("A", _)]), 
    (3, [1, 2, 3], "#Find", Const ("Input_Descript.valuesFor", _), [_ $ Free ("a", _) $ _, Const ("List.list.Cons", _) $ Free ("b", _) $ _]),
    (5, [3], "#Relate", Const ("Input_Descript.relations", _), _),
    (8, [3], "#undef", Const ("Input_Descript.boundVariable", _), [Free ("alpha", _)]),
    (10, [3], "#undef", Const ("Input_Descript.interval", _), _),
    (11, [1, 2, 3], "#undef", Const ("Input_Descript.errorBound", _), [Const ("HOL.eq", _) $ Free ("eps", _) $ Free ("0", _)])
  ]] => ()
| _ => error "fun O_Model.filter_vat CHANGED";


"----------- regression test fun O_Model.is_copy_named -----------------------------------------";
"----------- regression test fun O_Model.is_copy_named -----------------------------------------";
"----------- regression test fun O_Model.is_copy_named -----------------------------------------";
val trm = ("1", (TermC.empty, @{term "v'i'"}));
if O_Model.is_copy_named trm then () else error "regr. O_Model.is_copy_named 1";
val trm = ("1", (TermC.empty, @{term "e_e"}));
if O_Model.is_copy_named trm then error "regr. O_Model.is_copy_named 2" else ();
val trm = ("1", (TermC.empty, @{term "L'''"}));
if O_Model.is_copy_named trm then () else error "regr. O_Model.is_copy_named 3";

(* out-comment 'structure CalcHead'...
val trm = (1, (2, @{term "v'i'"}));
if is_copy_named_generating trm then () else error "regr. O_Model.is_copy_named";
val trm = (1, (2, @{term "L'''"}));
if is_copy_named_generating trm then error "regr. O_Model.is_copy_named" else ();
*)

"----------- .. CONTINUED regr.test fun O_Model.cpy_nam ----------------------------------------";
"----------- .. CONTINUED regr.test fun O_Model.cpy_nam ----------------------------------------";
"----------- .. CONTINUED regr.test fun O_Model.cpy_nam ----------------------------------------";
(*data from above - M_Match.arguments, is_cp, O_Model.cpy_nam +with EqSystem (!)-:*)
(*the model-pattern, O_Model.is_copy_named are filter_out*)
val pbt = [("#Given", (@{term "equality"}, @{term "e_e :: bool"})),
       ("#Given", (@{term "solveFor"}, @{term "v_v :: real"} ))];
(*the model specific for an example*)
val oris = [([1], "#Given", @{term "equality"} , [str2term "x+1= 2"]),
	([1], "#Given", @{term "solveFor"} , [@{term "x :: real"} ])];
val cy = [("#Find", (@{term "solutions"}, @{term "v_v'i' :: bool list"}))];
(*...all must be true*)

case O_Model.cpy_nam pbt oris (hd cy) of 
    ([1], "#Find", Const ("Input_Descript.solutions", _), [Free ("x_i", _)]) => ()
  | _ => error "calchead.sml regr.test O_Model.cpy_nam-1-";

(*new data: O_Model.cpy_nam without changing the name*)
@{term "equalities"}; type_of @{term "[x_1+1=2,x_2=0]"};
@{term "solveForVars"}; type_of @{term "[x_1,x_2]::real list"};
@{term "solution"}; type_of @{term "ss''' :: bool list"};
(*the model-pattern for ["LINEAR", "system"], O_Model.is_copy_named are filter_out*)
val pbt = [("#Given", (@{term "equalities"}, @{term "e_s :: bool list"})),
       ("#Given", (@{term "solveForVars v_s"}, @{term "v_s :: bool list"} ))];
(*the model specific for an example*)
val oris = [([1], "#Given", @{term "equalities"} ,[str2term "[x_1+1=2,x_2=0]"]),
    ([1], "#Given", @{term "solveForVars"} , [@{term "[x_1,x_2]::real list"}])];
val cy = [("#Find", (@{term "solution"}, @{term "ss''' :: bool list"}))
        (*could be more than 1*)];

case O_Model.cpy_nam pbt oris (hd cy) of
    ([1], "#Find", Const ("EqSystem.solution", _), [Free ("ss'''", _)]) => ()
  | _ => error "calchead.sml regr.test O_Model.cpy_nam-2-";

