(*  Title:  Interpret/refine.thy
    Author: Walther Neuper
   (c) due to copyright terms
*)

theory refine
imports Isac.Build_Isac
begin

text \<open>
  *setup* KEStore_Elems.add_pbts is impossible in *.sml files.
  The respective test/../refine.sml is called in Test_Isac.thy.
\<close>

section \<open>data for test "-ptyps.thy: store test-pbtyps by 'setup' ---"\<close>
setup \<open>KEStore_Elems.add_pbts
[(Problem.prep_input thy "pbl_test_refine" [] Problem.id_empty
  (["refine", "test"], [], Rule_Set.empty, NONE, [])),
(Problem.prep_input @{theory DiffApp} "pbl_pbla" [] Problem.id_empty
  (["pbla", "refine", "test"],         
  [("#Given", ["fixedValues a_a"])], Rule_Set.empty, NONE, [])),
(Problem.prep_input @{theory DiffApp} "pbl_pbla1" [] Problem.id_empty
  (["pbla1", "pbla", "refine", "test"], 
  [("#Given", ["fixedValues a_a", "maximum a_1"])], Rule_Set.empty, NONE, [])),
(Problem.prep_input @{theory DiffApp} "pbl_pbla2" [] Problem.id_empty
  (["pbla2", "pbla", "refine", "test"], 
  [("#Given", ["fixedValues a_a", "valuesFor a_2"])], Rule_Set.empty, NONE, [])),
(Problem.prep_input @{theory DiffApp} "pbl_pbla2x" [] Problem.id_empty
  (["pbla2x", "pbla2", "pbla", "refine", "test"],
  [("#Given", ["fixedValues a_a", "valuesFor a_2", "functionOf a2_x"])], 
  Rule_Set.empty, NONE, [])),
(Problem.prep_input @{theory DiffApp} "pbl_pbla2y" [] Problem.id_empty
  (["pbla2y", "pbla2", "pbla", "refine", "test"],
  [("#Given" ,["fixedValues a_a", "valuesFor a_2", "boundVariable a2_y"])], 
  Rule_Set.empty, NONE, [])),
(Problem.prep_input @{theory DiffApp} "pbl_pbla2z" [] Problem.id_empty
  (["pbla2z", "pbla2", "pbla", "refine", "test"],
  [("#Given" ,["fixedValues a_a", "valuesFor a_2", "interval a2_z"])], 
  Rule_Set.empty, NONE, [])),
(Problem.prep_input @{theory DiffApp} "pbl_pbla3" [] Problem.id_empty
 (["pbla3", "pbla", "refine", "test"],
  [("#Given" ,["fixedValues a_a", "relations a_3"])], 
  Rule_Set.empty, NONE, []))]
\<close>

(*ML_file "~~/test/Tools/isac/Specify/refine.sml" ... is called in Test_Isac.thy below,
  so do NOT call it HERE; ?circularity*) 

end
